<?php
try {
    require('cfg.php');
} catch (\Throwable $th) {
    $rest = new RestResponse(false, null);
                $rest->toJson()->setMessage($th->getMessage());
}

try {
    $auth = new auth();
    if ($auth->verify($auth->found())->status()) {
        $user=$auth->getUser();
    } else {
        $user='';
    }
    $hash = $_GET['cart_token'];

} catch (\Throwable $th) {
    $rest = new RestResponse(false, null);
                $rest->toJson()->setMessage($th->getMessage());
    
}
    $requestMethod = $_SERVER["REQUEST_METHOD"];
    if(isset($_GET['action'])){
        $action = $_GET['action'];
    }
    //die(var_dump([$user, $hash]));
    
    $data = json_decode(file_get_contents("php://input"));
    switch ($requestMethod) {
        case 'GET':
            
            switch ($action) {
                case 'status':
                    try {
                        $wl=new Cart($user, $hash);          
                        $rest = new RestResponse(true,$wl->getCartItemsStatus());
                        $rest->toJson()->setMessage('OK');
                    } catch (\Throwable $th) {
                        $rest = new RestResponse(false, null);
                        $rest->toJson()->setMessage($th->getMessage());
                    }
                    break;

                default:
                    try {
                        $wl=new Cart($user, $hash);          
                        $rest = new RestResponse(true,$wl->getItems());
                        $rest->toJson()->setMessage('OK');
                    } catch (\Throwable $th) {
                        $rest = new RestResponse(false, null);
                        $rest->toJson()->setMessage($th->getMessage());
                    }
                    break;
            }
            break;
        case 'POST':
            switch ($action) {
                case 'updateItems':
                    $cart_item_id = $data->product_id;
                    $variation_id = $data->variation_id;
                    $value = $data->quantity;
                    try {
                        $cart = new Cart($user, $hash);
                        $cart->update($cart_item_id, $value, $variation_id);
                        $rest = new RestResponse(true,$cart->getItems());
                        $rest->toJson()->setMessage('OK');
                    } catch (\Throwable $th) {
                        $rest = new RestResponse(false, null);
                $rest->toJson()->setMessage($th->getMessage());
                    }
                    break;
                
                case 'addCartItem':
                    $cart_item = [
                        'product_id' => $data->product_id,
                        'quantity' => $data->quantity,
                        'variation_id' => $data->variation_id
                    ];
                    try {
                        $wl=new Cart($user, $hash);   
                        $wl->insert($cart_item);
                        $rest = new RestResponse(true,$wl->getItems());
                        $rest->toJson()->setMessage('OK');
                    } catch (\Throwable $th) {
                        $rest = new RestResponse(false, null);
                $rest->toJson()->setMessage($th->getMessage());
                    }
                    break;
                case 'deleteItems':
                    $cart_item_id = $data->product_id;
                    $variation_id = $data->variation_id;
                    try {
                        $cart = new Cart($user, $hash);
                        $cart->remove($cart_item_id, $variation_id);
                        $rest = new RestResponse(true,$cart->getItems());
                        $rest->toJson()->setMessage('OK');
                    } catch (\Throwable $th) {
                        $rest = new RestResponse(false, null);
                $rest->toJson()->setMessage($th->getMessage());
                    }
                    break;
                case 'destroyCart':
                    try {
                        $cart = new Cart($user, $hash);
                        $cart->destroy();
                        $rest = new RestResponse(true,$cart->getItems());
                        $rest->toJson()->setMessage('OK');
                    } catch (\Throwable $th) {
                        $rest = new RestResponse(false, null);
                $rest->toJson()->setMessage($th->getMessage());
                    }
                    break;
            }
            
            break;
        case 'PUT':
            
            break;
        case 'DELETE':
                        
            break;
        default:
            
        
            break;
    }

if(!isset($rest) || !is_object($rest)){
    $rest = new RestResponse(false,null);
    $rest->toJson()->setMessage('Acceso Restringido');
}
$rest->execute();

