<?php
require('./cfg.php');

use Aws\S3\S3Client;
use Aws\S3\Exception\S3Exception;

$auth = new auth();
if ($auth->verify($auth->found())->status()) {
    $requestMethod = $_SERVER["REQUEST_METHOD"];
    switch ($requestMethod) {
        case 'POST':
            switch ($_GET["action"]) {
                case 'profile_documentation':
                    try {
                        if(isset($_FILES['file'])){
                            $s3Client = new S3Client([
                                'version' => 'latest',
                                'region'  => AWS_REGION, // Your AWS region
                                'credentials' => [
                                    'key'    => AWS_ACCESS_KEY,
                                    'secret' => AWS_ACCESS_SECRET
                                ]
                            ]);
                            $fl=explode('.',$_FILES['file']['name']);
                            $ext=$fl[1];
                            $filename = wp_generate_uuid4() . '.' . $ext;
                            $aswPath = 'uploads/profile_data/' . $auth->getUser() . '/' . $filename;
                            
                            if (file_exists($_FILES['file']['tmp_name'])) {
                                $s3Client->putObject(array(
                                    'Bucket' => AWS_BUCKET,
                                    'Key' => $aswPath,
                                    'Body' => fopen($_FILES['file']['tmp_name'], 'r'),
                                    'ACL' => 'public-read',
                                    'ContentType' => $_FILES['file']['Content-Type'],
                                ));
                            } else {
                                throw new Exception("file not found", 1);
                            }
                            $response['file_url'] = 'https://d1u9bbhcasux7c.cloudfront.net/'.$aswPath;
                            $rest = new RestResponse(true, $response);
                            $rest->toJson()->setMessage('OK');
                        }else{
                            $response['message'] = 'No se subió ningún archivo.';
                            $rest = new RestResponse(false, $response);
                            $rest->toJson()->setMessage('No se subió ningún archivo.');
                        }
                    }catch (S3Exception $e) {
                        echo $e->getMessage() . "\n";
                    } catch (\Throwable $th) {
                        die($th);
                    }
                    break;

                default:
                    # code...
                    break;
            }
            break;
    }
}
if (!isset($rest) || !is_object($rest)) {
    $rest = new RestResponse(false, null);
    $rest->toJson()->setMessage('Acceso Restringido');
}
$rest->execute();
