<?php 

if (isset($_SERVER['HTTP_ORIGIN'])) {
    header("Access-Control-Allow-Origin: {$_SERVER['HTTP_ORIGIN']}");
    header('Access-Control-Allow-Credentials: true');
    header('Access-Control-Max-Age: 86400');
    header('Access-Control-Allow-Methods: GET, POST, PUT, DELETE, OPTIONS');
    header('Access-Control-Allow-Headers: Origin, Content-Type, X-Auth-Token');
}
if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {
    if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_METHOD']))
        header("Access-Control-Allow-Methods: GET, POST, OPTIONS");
    if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']))
        header("Access-Control-Allow-Headers: {$_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']}");
    exit(0);
}

$faqs = [
    [
        "question" => "¿Qué es Bridgemarkets? O ¿Cuál es su servicio?",
        "answer" => "Somos una plataforma de comercio electrónico exclusivo de empresas en la Zona Libre de Colón donde usted puede adquirir al por mayor productos de diversos departamentos en un solo lugar. Estamos enfocados en aportar valor y diseñar oportunidades para las empresas PYMES y el mercado de emprendedores en América Latina y El Caribe.<br><br>
 
        Ventajas:<br>
        <ul>
            <li>Productos de Asia, Europa, Medio Oriente y América en un solo lugar</li>
            <li>Pasarela de pago y logística integrados.</li>
            <li>Disponibilidad de productos inmediata.</li>
            <li>Tiempos de entregas más cortos desde Panamá.</li>
        </ul>"
    ],
    [
        "question" => "¿Qué productos puedo comprar en Bridgemarkets?",
        "answer" => "Cada semana se están sumando nuevos proveedores, categorías y productos. <br>
        Para ver nuestras categorías de productos disponibles puede ingresar en el siguiente <a href='/angular/categorias'>link</a>"
    ],
    [
        "question" => "¿Cómo comprar?",
        "answer" => "A continuación, te explicamos paso a paso cómo puedes crear una cuenta en nuestra plataforma y realizar una compra:
            <ul>
                <li>Ingresa al siguiente <a href='/angular/mi-cuenta'>link</a> y regístrate.</li>
                <li>Una vez completado el registro puedes agregar productos a tu carrito de compras.</li>
            </ul><br>
            * Para completar el pedido se le solicitarán datos adicionales, una vez diligenciados los datos
            puede completar su pedido."
    ],
    [
        "question" => "¿En qué países opera bridgemarkets?",
        "answer" => "Bridgemarkets se encuentra ubicada en la Zona Franca más importante del mundo, la Zona Libre de Colón en Panamá. Desde aquí atendemos a compradores de todo el Continente Americano, El Caribe y la Costa Este de EE. UU., quienes pueden hacer sus pedidos en línea en www.bridgemarkets.com"
    ],
    [
        "question" => "¿Qué significa MOQ?",
        "answer" => "El MOQ es un acrónimo en inglés de “Minimum Order Quantity” y hace referencia a la cantidad mínima de compra del producto consultado. Ejemplo: Si un bombillo está acompañado del término MOQ y dice 12 unidades (una docena) quiere decir que para adquirir ese bombillo es necesario comprar 12 unidades o 24 unidades o 36 unidades y así sucesivamente."
    ],
    [
        "question" => "¿Dónde están ubicadas las oficinas?",
        "answer" => "Nuestras oficinas están en el Centro Comercial Interplaza, Edificio Apolo, piso 4, oficina 520. Estamos para atenderle de 8 de la mañana a 5 de la tarde. Google Maps:<br> <a targe='_blank' href='https://goo.gl/maps/mhQQEYMjh4WcsKpC6'>https://goo.gl/maps/mhQQEYMjh4WcsKpC6</a>"
    ],
    [
        "question" => "¿Tiene alguna línea directa para atención al cliente?",
        "answer" => "Para cualquier consulta nos puede contactar a través de estas opciones:<br>
        <ul>
            <li>Teléfono: +507 201-8474</li>
            <li>WhatsApp Business: +507 6210-8489</li>
            <li>Correo: info@bridgetmarkets.com</li>
        </ul>"
    ],
    
];

echo json_encode($faqs);

?>
