<?php

namespace BulkUpload;

class Country {

    public string $cca2;
    public string $cca3;
    public string $ccn3;
    public string $cioc;
    public string $name;
    public string $prefix;
    public string $pngFlag;
    public string $svgFlag;
    public array $languages;
    public array $timeZones;
    public string $isUnMember;
    public array $currencies;
    public array $translations;
    public string $startDayOfWeek;
    public string $postalCodeRegex;

    public function __construct($countryData)
    {

        $this->cca2 = $countryData['cca2'];
        $this->cca3 = $countryData['cca3'];
        $this->ccn3 = $countryData['ccn3'];
        $this->cioc = $countryData['cioc'];
        $this->name = $countryData['name'];
        $this->prefix = $countryData['prefix'];
        $this->pngFlag = $countryData['png_flag'];
        $this->svgFlag = $countryData['svg_flag'];
        $this->cca2 = $countryData['languages'];
        $this->cca2 = $countryData['timezones'];
        $this->cca2 = $countryData['un_member'];
        $this->cca2 = $countryData['currencies'];
        $this->cca2 = $countryData['translations'];
        $this->cca2 = $countryData['start_of_week'];
        $this->cca2 = $countryData['postal_code_regex'];

    }

    /**
     * Returns a key => value array with the cca2 code as key and the list of available 
     * names for the country as value.
     *
     * @return array
     */
    public function returnBulkUploadValidFormats():array{

        $validFormats = [
            $this->cca2, 
            $this->cca3, 
            $this->ccn3, 
            $this->cioc,
            $this->name
        ];

        foreach ($this->translations as $translate) {
            array_push($validFormats, $translate['common']);
        }

        return [$this->cca2 => $validFormats]??[$this->cca2 => array()];

    }
}