<?php

namespace BulkUpload\Validation\Rules;

use BulkUpload\Validation\Rule;

class Count extends Rule{

    public array $errors = [];
    private int $count;

    public function __construct(int $count)
    {
        $this->count = $count;
    }

    public function validate(mixed $data, $errors){

        switch (gettype($data)) {
            case 'string':
                if(strlen(trim($data)) != $this->count){
                    array_push($this->errors, 'La cantidad de carácteres debe ser igual a '.$this->count);
                }
                return parent::validate($data, array_merge($this->errors, $errors));

            case 'array':
                if(count($data) != $this->count){
                    array_push($this->errors, 'La cantidad de elementos en el arreglo debe ser igual a '.$this->count);
                }
                return parent::validate($data, array_merge($this->errors, $errors));
            case 'double':
                if(strlen(strval($data)) != $this->count){
                    array_push($this->errors, 'La cantidad de dígitos del valor ingresado debe ser igual a '.$this->count);
                }
                return parent::validate($data, array_merge($this->errors, $errors));
            case 'integer':
                if(strlen(strval($data)) != $this->count){
                    array_push($this->errors, 'La cantidad de dígitos del valor ingresado debe ser igual a '.$this->count);
                }
                return parent::validate($data, array_merge($this->errors, $errors));
        }

    }

}