<?php

namespace BulkUpload\Validation\Rules;

use BulkUpload\Factories\SimpleProduct;
use BulkUpload\Validation\Rule;

class Sku extends Rule{

    public array $errors = [];
    private int $vendor_id;
    private int $product_id;

    public function __construct(int $vendor_id, int $product_id = 0)
    {
        $this->vendor_id = $vendor_id;
        $this->product_id = $product_id;
    }

    public function validate(mixed $data, $errors){

        $productFactory = new SimpleProduct();

        switch ($this->product_id) {
            case 0:
                if($productFactory->is_existing_sku($this->vendor_id, $data, $this->product_id)){
                    array_push($this->errors, 'El sku '.$data.' ya está siendo usado.');
                }
                return parent::validate($data, array_merge($this->errors, $errors));
            
            default:
                if($productFactory->is_existing_sku($this->vendor_id, $data)){
                    array_push($this->errors, 'El sku '.$data.' ya está siendo usado.');
                }
                return parent::validate($data, array_merge($this->errors, $errors));
        }

            

    }

}