<?php

class Retargeting
{
    private $db;
    private $functions;
    private $templateType = 'email_retargeting';
    private $templateId = 0;
    private $templateData = [];
    private $schedule = [];
    private $carts = [];
    private $categories = [];
    private $response = [];
    private $category_template = '
    <div class="category" style="padding: 12px; text-align:center; border-radius: 12px; border: 1px solid #E2E8F0; background: #FFF;">
    <a href="{category_link}" target="_blank" rel="noopener noreferrer" style="text-decoration: none;">
        <img src="{category_image}" alt="" style="color: #FFF; font-size: 10px; font-style: normal; font-weight: 600; line-height: 14px; letter-spacing: -0.2px; margin:0px; vertical-align:bottom; height:130px; width:130px; padding: 12px; border-radius: 12px; background-size: cover; background-repeat: no-repeat; background-position: center;">
    </a></div>';
    private $card_template = '
    <div class="card" style="display: block; margin-bottom: 15px; padding: 10px 16px; border-radius: 16px; background: #FFF;">
                            <table width="100%" style="border: none; border-collapse: collapse; margin-bottom: 15px;">
                                <tr style="border: none; border-collapse: collapse;">
                                    <td style="border: none; border-collapse: collapse;text-align: left;">
                                        <span style="color: #1E293B; font-size: 16px; font-style: normal; font-weight: 600; line-height: 20px; letter-spacing: -0.32px;text-align: left;">
                                            {vendor_name}
                                        </span>
                                    </td>
                                    <td style="border: none; border-collapse: collapse;text-align: right;">
                                        <span style="color: #1E293B; font-size: 16px; font-style: normal; font-weight: 600; line-height: 20px; letter-spacing: -0.32px;text-align: right;">
                                            $USD {total_by_vendor}
                                        </span>
                                    </td>
                                </tr>
                            </table>
                            {products}
                        </div>';
    private $product_template = '
    <table width="100%" style="border: none; border-collapse: collapse; margin-bottom: 15px;">
    <tr style="border: none; border-collapse: collapse;">
        <td style="border: none; border-collapse: collapse;">
            <a href="{product_link}" target="_blank" rel="noopener noreferrer" style="text-decoration: none;">
                <img src="{product_image}" alt="" style="display: flex; width: 120px; height: 120px; margin-right: 15px; aspect-ratio: 1/1; padding: 8px; flex-direction: column; align-items: flex-start; gap: 12px; border-radius: 12px; background-size: cover; background-repeat: no-repeat; background-position: center;" />
            </a>
        </td>
        <td style="border: none; border-collapse: collapse;width:100%;">
            <table width="100%" style="border: none; border-collapse: collapse; margin-bottom: 8px;">
                <tr style="border: none; border-collapse: collapse;width:100%;">
                    <td style="border: none; border-collapse: collapse;width:100%;text-align: left;">
                        <a href="{product_link}" target="_blank" rel="noopener noreferrer" style="text-decoration: none;">
                            <span class="product-name" style="color: var(--blue-gray-blue-gray-800, #1E293B); font-size: 14px; font-style: normal; font-weight: 600; line-height: 20px; letter-spacing: -0.28px;">{product_name}</span>
                        </a>
                    </td>
                </tr>
                <tr style="border: none; border-collapse: collapse;width:100%;">
                    <td style="border: none; border-collapse: collapse;width:100%;text-align: left;">
                        <span class="variation" style="color: var(--blue-gray-blue-gray-800, #1E293B); font-size: 14px; font-style: normal; font-weight: 500; line-height: 20px; letter-spacing: -0.28px;">{product_variation}</span>
                    </td>
                </tr>
                <tr style="border: none; border-collapse: collapse;width:100%;">
                    <td style="border: none; border-collapse: collapse;width:100%;text-align: left;">
                        <span class="sku" style="color: var(--blue-gray-blue-gray-800, #1E293B); font-size: 14px; font-style: normal; font-weight: 400; line-height: 20px; letter-spacing: -0.28px;">{product_sku}</span>
                    </td>
                </tr>
                <tr style="border: none; border-collapse: collapse;width:100%;">
                    <td style="border: none; border-collapse: collapse;width:100%;text-align: left;">
                        <span class="circle" style="display: inline-block; min-width: 20px; height: 20px; vertical-align:middle; max-height: 20px; flex-direction: column; justify-content: center; flex-shrink: 0; border-radius: 10px; background: #F3F4F6; font-size: 10px; font-style: normal; font-weight: 500; line-height: 18px; letter-spacing: -0.2px; color: #1E293B; text-align: center;">{product_total_items}</span>
                        <span class="x" style="color: var(--blue-gray-blue-gray-500, #64748B); font-size: 14px; font-style: normal; font-weight: 400; line-height: 14px; letter-spacing: -0.28px;">X</span>
                        <span class="unit-price" style="color: var(--blue-gray-blue-gray-800, #1E293B); font-size: 14px; font-style: normal; font-weight: 400; line-height: 22px; letter-spacing: -0.28px;">$USD {product_unit_price}</span>
                    </td>
                </tr>
                <tr style="border: none; border-collapse: collapse;width:100%;">
                    <td style="border: none; border-collapse: collapse;width:100%;text-align: left;">
                        <span class="price" style="color: var(--blue-gray-blue-gray-800, #1E293B); font-size: 16px; font-style: normal; font-weight: 600; line-height: 22px; letter-spacing: -0.32px;">Total $USD {product_total}</span>
                    </td>
                </tr>
            </table>
        </td>
    </tr>
</table>';

    public function __construct()
    {
        $this->db = new collection();
        $this->functions = new ProductFunctions();
        $cats = new Categories();
        $this->categories = $cats->getAllData(false)->getCategories();
        $this->categories = array_filter($this->categories, fn ($item) => $item['image'] != '');
        $this->loadSchedule();
        set_time_limit(300);
    }


    public function sendEmails()
    {
        $this->loadCarts();
        $this->prepareAndSendEmails();
    }

    public function sendEmailsForAll()
    {
        $this->loadAllCarts();
        $this->prepareAndSendEmails();
    }

    private function prepareAndSendEmails()
    {
        for ($i = 0; $i < $this->carts['cant_rows']; $i++) {
            /* if ($this->carts[$i]['id_user'] != 804) {
                continue;
            } */
            $current = $this->carts[$i];
            $user = new User($current['id_user']);
            $cart = new Cart($current['id_user'], $current['id_user']);
            $vars = $this->extractUserVars($user);
            $vars['{website}'] = $GLOBALS['domain_root'];
            $vars['{title}'] = $this->replaceData(utf8_decode($this->templateData['title']), $vars);
            $vars['{message}'] = $this->replaceData(utf8_decode($this->templateData['message']), $vars);
            $vars['{products}'] = utf8_decode($this->buildProductGrid($cart));
            $this->loadCategoryTemplate($vars);
            $content = $this->templateData['content'];
            $email = new email();
            $email->set_destination($user->email);
            $email->setReplace($vars);
            $email->set_template($this->templateData['subject'], $content);
            if (!$email->send_mail()) {
            /* if (!$email->show_mail()) { */
                $this->response['error'][] = $user->email;
            } else {
                $this->response['success'][] = $user->email;
            }
            unset($vars);
            unset($email);
            unset($cart);
            unset($user);
            unset($current);
            unset($content);
        }
        header('Content-Type: application/json');
        die(json_encode($this->response, JSON_PARTIAL_OUTPUT_ON_ERROR));
    }


    private function buildProductGrid(Cart $cart): string
    {
        $grid = '';
        $prods = $cart->getItems()['cart_items'];
        shuffle($prods);
        $items = array_slice($prods, 0, 4, true);
        $vendor = [];
        foreach ($items as $key => $value) {
            $vendor[$value['info']['vendor_slug']]['vendor_name'] = $value['info']['vendor'];
            $vendor[$value['info']['vendor_slug']]['items'][] = $value;
        }
        foreach ($vendor as $key => $value) {
            $products = '';
            foreach ($value['items'] as $key => $item) {
                $products .= $this->loadProductTemplate($item);
            }
            $grid .= $this->loadCardTemplate($value['vendor_name'], $this->functions->getTotals($value['items']), $products);
        }
        return $grid;
    }

    private function loadCardTemplate($vendor_name, $total, $products)
    {
        $template = $this->card_template;
        $replace = [
            '{vendor_name}' => $vendor_name,
            '{total_by_vendor}' => number_format($total, 2),
            '{products}' => $products,
        ];
        foreach ($replace as $key => $value) {
            $template = str_replace($key, $value, $template);
        }
        return $template;
    }
    private function loadProductTemplate($product)
    {
        $template = $this->product_template;
        $qty = $product['quantity'];
        $moq = $this->functions->getData('moq', $product);
        $price = $this->functions->getCurrentPrice($product);
        $replace = [
            '{product_image}' => $this->functions->getData('images', $product)[0]['url'],
            '{product_name}' => $this->functions->getData('name', $product),
            '{product_variation}' => $this->functions->getAttributes($product),
            '{product_sku}' => $this->functions->getData('sku', $product),
            '{product_total_items}' => intval($moq) * intval($qty),
            '{product_unit_price}' => number_format(floatval($price), 2),
            '{product_total}' => number_format($this->functions->itemsTotal($product), 2),
            '{product_link}' => $GLOBALS['domain_root'].'detalle/'.$product['info']['slug'],
        ];
        foreach ($replace as $key => $value) {
            $template = str_replace($key, $value, $template);
        }
        return $template;
    }
    private function loadCategoryTemplate(&$var)
    {
        $template = $this->category_template;
        shuffle($this->categories);
        for ($i = 0; $i < 4; $i++) {
            $replace = [
                '{category_image}' => $this->categories[$i]['image'],
                '{category_name}' => $this->categories[$i]['description'],
                '{category_link}' => $GLOBALS['domain_root'].'listado/'.$this->categories[$i]['slug'],
            ];
            $var['{cat_' . $i . '}'] = $this->replaceData($template, $replace);
        }
        return;
    }

    private function replaceData($template, $vars)
    {
        foreach ($vars as $key => $value) {
            $template = str_replace($key, $value, $template);
        }
        return $template;
    }

    private function extractUserVars(User $user): array
    {
        $vars = [];
        foreach ($user->toArray() as $key => $value) {
            if ($key == 'meta_data') {
                foreach ($value as $k => $meta) {
                    if (!is_array($meta['value'])) {
                        $vars['{' . $meta['key'] . '}'] = $meta['value'];
                    }
                }
            } else {
                if (!is_array($value)) {
                    $vars['{' . $key . '}'] = $value;
                }
            }
        }
        return $vars;
    }

    private function loadCarts()
    {
        $query = "SELECT
	ng_cart.id_cart,
	ng_cart.id_user,
	Count(OvMdW_posts.ID) AS items_added
FROM
	ng_cart
INNER JOIN OvMdW_users ON CAST(OvMdW_users.ID as CHAR(60) CHARACTER SET utf8mb4) = ng_cart.id_user
INNER JOIN ng_cart_items ON ng_cart_items.cart_id = ng_cart.id_cart
INNER JOIN OvMdW_posts ON OvMdW_posts.ID = ng_cart_items.product_id
WHERE
    TIMESTAMPDIFF(HOUR, ng_cart.modified_at, NOW()) IN (" . implode(',', $this->schedule) . ") AND
    ng_cart.`status` = 1 AND
    OvMdW_posts.post_status = 'publish'
    GROUP BY
	ng_cart.id_cart,
	OvMdW_users.user_email,
	ng_cart.id_user";
        $this->carts = $this->db->plainQuery($query, false, true);
    }

    private function loadAllCarts()
    {
        $query = "SELECT
	ng_cart.id_cart,
	ng_cart.id_user,
	Count(OvMdW_posts.ID) AS items_added
FROM
	ng_cart
INNER JOIN OvMdW_users ON CAST(OvMdW_users.ID as CHAR(60) CHARACTER SET utf8mb4) = ng_cart.id_user
INNER JOIN ng_cart_items ON ng_cart_items.cart_id = ng_cart.id_cart
INNER JOIN OvMdW_posts ON OvMdW_posts.ID = ng_cart_items.product_id
WHERE
    ng_cart.`status` = 1 AND
    OvMdW_posts.post_status = 'publish'
    GROUP BY
	ng_cart.id_cart,
	OvMdW_users.user_email,
	ng_cart.id_user";
        $this->carts = $this->db->plainQuery($query, false, true);
    }

    private function loadSchedule()
    {
        $this->templateData = $this->db->searchForce('bm_email_template', array('status' => '1', 'type' => 'email_retargeting'), 'AND', 'DEFAULT_WHERE', 1)[0];
        if (!$this->templateData) {
            die();
        }
        $this->templateId = $this->templateData['id_template'];
        $schedule = $this->db->searchForce('email_scheduling', array('id_template' => $this->templateId), 'AND', 'DEFAULT_WHERE', '10', 'days ASC, hours ASC');
        if (!$schedule || $schedule['cant_rows'] == 0) {
            die();
        }
        for ($i = 0; $i < $schedule['cant_rows']; $i++) {
            $this->schedule[] = (intval($schedule[$i]['days']) * 24) + intval($schedule[$i]['hours']);
        }
    }
}
