<?php
class SmsMessages
{

    private $account_sid = TWILIO_ACCOUNT_ID;
    private $auth_token = TWILIO_TOKEN;
    private $twilio_number = TWILIO_NUMBER;
    private $client;
    private $text;
    private $lang;
    private $logged = true;
    private $activateSMS = (SENDSMS == 1) ? true : false;

    public function __construct()
    {
        if ($this->activateSMS) {
            $this->client = new Twilio\Rest\Client($this->account_sid, $this->auth_token);
        }
    }

    public function sendMessage($phone, $text)
    {
        if ($this->activateSMS) {
            $this->client->messages->create(
                $phone,
                array(
                    'from' => $this->twilio_number,
                    'body' => $text,
                )
            );
        }
    }
    public function replace_data($vars = array())
    {
        foreach ($vars as $key => $value) {
            $this->text = str_replace($key, $value, $this->text);
        }
        return $this;
    }

    public function GetStatus()
    {
        return $this->client->messages->read();
    }

    public function setLang($l)
    {
        $this->lang = $l;
        return $this;
    }

    public function load_template($text,$vars=array())
    {
        if ($text != '') {            
            $this->text = $text;
            $this->replace_data($vars);
        }
        return $this;
    }

    public function sendMessageTemplate($phone, $template, $vars = array())
    {
        $this->load_template($template, $vars);
        if ($this->activateSMS) {
            try {
                $this->client->messages->create(
                    $phone,
                    array(
                        'from' => $this->twilio_number,
                        'body' => $this->text,
                    )
                );
                return true;
            } catch (\Exception $e) {
                return false;
            }
        }
    }
}