<?php 

class BuyTendency extends MetaValues {    

    private $db;
    private $user_id;
    private $exist = false;
    private $data=array();
    private $cats=array();
    private $downgradeValue = 5;
    private $upgradeValue = 25;

    public function __construct($user_id){

        $this->db = new collection;
        $this->user_id = $user_id;
        $this->getCurrentData();
        return $this;
    }

    public function updateData(array $cats,int $priority=1)
    {
       $this->cats = $cats;
       $this->recalculate($priority);
       $this->setData();
       return $this;
    }


    private function setData()
    {
        if($this->exist){
            $this->update();
        }else{
            $this->insert();
        }
    }

    public function getData()
    {
        return $this->data;
    }

    private function getCurrentData()
    {
       $data= $this->db->search('search_history',array('user_id' => $this->user_id),'AND','DEFAULT_WHERE',1);
       if($data['cant_rows']==0){
        return false;
       }
       $this->data=$this->maybe_unserialize($data[0]['data']);
       $this->exist=true;
       return $this;
    }
    private function update()
    {
        $this->db->update('search_history',array('user_id' => $this->user_id),array('data'=>$this->maybe_serialize($this->data)));
    }
    private function insert()
    {
        $this->db->insert('search_history',array('user_id' => $this->user_id,'data'=>$this->maybe_serialize($this->data)));
    }
    private function recalculate(int $priority=1)
    {
        $newData=[];

        if(count($this->data)>0){
            foreach ($this->cats as $cat) {
                if(isset($this->data[$cat])){
                    $this->data[$cat]=(($this->data[$cat]+($this->upgradeValue*$priority)>100))?100:$this->data[$cat]+($this->upgradeValue*$priority);
                }else{
                    $this->data[$cat]=$this->upgradeValue*$priority;
                }
            }
            foreach ($this->data as $key => $value) {
                if(!in_array($key,$this->cats)){
                    $this->data[$key]=(($this->data[$key]-($this->downgradeValue)<0))?0:$this->data[$key]-($this->downgradeValue);
                }
            }            
        }else{
            foreach ($this->cats as $cat) {
                $this->data[$cat]=$this->upgradeValue*$priority;
            }
        }  
             
        arsort($this->data);
    }
}



