<?php

class Categories
{
    private $categories = [];
    private $cat_index = [];
    private $images = [];
    private $level_list = [];
    private $inactive_products = [];
    private $current_level = 1;
    private $db;


    public function __construct()
    {
        $this->db = new collection();
        $this->getInactive();
    }

    private function getInactive()
    {
        $inatives = $this->db->plainQuery("
        SELECT
        Count(a.object_id) AS inactives,
        b.term_id
        FROM
        OvMdW_term_relationships AS a
        INNER JOIN OvMdW_term_taxonomy AS b ON a.term_taxonomy_id = b.term_taxonomy_id
        INNER JOIN OvMdW_postmeta ON OvMdW_postmeta.post_id = a.object_id
        INNER JOIN OvMdW_posts ON OvMdW_posts.ID = a.object_id
        WHERE
        b.taxonomy = 'product_cat' AND
        OvMdW_postmeta.meta_key = '_visibility' AND
        OvMdW_postmeta.meta_value = 'hidden' AND
        OvMdW_posts.post_status = 'publish'
        GROUP BY
        b.term_id
        ");
        for ($i = 0; $i < $inatives['cant_rows']; $i++) {
            $this->inactive_products[$inatives[$i]['term_id']] = $inatives[$i]['inactives'];
        }
        unset($inatives);
        //die(print_r($this->inactive_products));
        return;
    }

    public function getCategories()
    {
        return $this->categories;
    }
    public function search_categories($term){
        $this->search_categories_routine($term);
        return array('category' => $this->categories, 'count' => 1);

    }
    private function search_categories_routine($term){
        $query = str_replace(
            'ovmdw_',
            TABLE_PREFIX,
            "SELECT
            OvMdW_terms.term_id,
            OvMdW_terms.`name` as description,
            OvMdW_terms.slug,
            OvMdW_term_taxonomy.taxonomy,
            OvMdW_term_taxonomy.parent
            FROM
            OvMdW_terms
            INNER JOIN OvMdW_term_taxonomy ON OvMdW_term_taxonomy.term_id = OvMdW_terms.term_id
            WHERE
            OvMdW_term_taxonomy.taxonomy = 'product_cat' AND
            OvMdW_term_taxonomy.parent = 0 AND
            OvMdW_terms.name LIKE '".$term."%';"
        );
        $dt_list = $this->db->plainQuery($query);
        //die(var_dump($dt_list));
        if (isset($dt_list['cant_rows']) && $dt_list['cant_rows'] > 0) {
            for ($k = 0; $k < $dt_list['cant_rows']; $k++) {
                $data[$k]['id'] = $dt_list[$k]['term_id'];
                $data[$k]['label'] = $dt_list[$k]['description'];
                $data[$k]['value'] = ($dt_list[$k]['term_id']);
            }
        }
        $this->categories = $data;
    }
    public function find($slug)
    {
        if ($slug == '') {
            return;
        }
        $stack = [];
        $query = str_replace(
            'ovmdw_',
            TABLE_PREFIX,
            "SELECT
            OvMdW_terms.term_id,
            OvMdW_terms.`name` as description,
            OvMdW_terms.slug,
            OvMdW_term_taxonomy.taxonomy,
            OvMdW_term_taxonomy.parent
            FROM
            OvMdW_terms
            INNER JOIN OvMdW_term_taxonomy ON OvMdW_term_taxonomy.term_id = OvMdW_terms.term_id
            WHERE
            OvMdW_term_taxonomy.taxonomy = 'product_cat' AND
            OvMdW_terms.slug = '" . $slug . "'
            LIMIT 1"
        );

        $data = $this->db->plainQuery($query);
        if ($data[0]['parent'] != 0) {
            foreach ($this->recursiveChildFinder($data[0]['parent']) as $key => $value) {
                if ($value) {
                    array_push($stack, $value);
                }
            }
        }
        unset($data[0]['parent']);
        array_push($stack, $data[0]);
        return $stack;
    }

    private function recursiveChildFinder($parent)
    {

        $stack = [];
        $query = str_replace(
            'ovmdw_',
            TABLE_PREFIX,
            "SELECT
            OvMdW_terms.term_id,
            OvMdW_terms.`name` as description,
            OvMdW_terms.slug,
            OvMdW_term_taxonomy.taxonomy,
            OvMdW_term_taxonomy.parent
            FROM
            OvMdW_terms
            INNER JOIN OvMdW_term_taxonomy ON OvMdW_term_taxonomy.term_id = OvMdW_terms.term_id
            WHERE
            OvMdW_term_taxonomy.taxonomy = 'product_cat' AND
            OvMdW_terms.term_id = '" . $parent . "'
            LIMIT 1"
        );

        $data = $this->db->plainQuery($query);
        //echo print_r($data[0]);

        if ($parent != 0) {
            foreach ($this->recursiveChildFinder($data[0]['parent']) as $key => $value) {
                if ($value) {
                    array_push($stack, $value);
                }
            }
        }
        unset($data[0]['parent']);
        array_push($stack, $data[0]);
        return $stack;
    }

    public function getAllData($extend = true)
    {
        $this->getCategoriesMaster($extend);
        return $this;
    }

    private function getIndexList()
    {
        # code...
    }
    public function getImage($id)
    {
        $query = str_replace(
            'ovmdw_',
            TABLE_PREFIX,
            "SELECT
            ovmdw_postmeta.meta_value AS img
            FROM
            ovmdw_posts
            INNER JOIN ovmdw_postmeta ON ovmdw_postmeta.post_id = ovmdw_posts.ID
            WHERE
            ovmdw_posts.ID IN ((SELECT
            ovmdw_termmeta.meta_value
            FROM
            ovmdw_termmeta
            WHERE
            ovmdw_termmeta.meta_key = 'thumbnail_id' AND
            ovmdw_termmeta.term_id = " . $id . ")) AND
            ovmdw_postmeta.meta_key = '_wp_attached_file'
            GROUP BY
            ovmdw_postmeta.meta_id,
            ovmdw_postmeta.meta_key,
            ovmdw_postmeta.meta_value
            LIMIT 1"
        );
        die($query);
        $data = $this->db->plainQuery($query);
        if ($data['cant_rows']) {
            return 'https://d1u9bbhcasux7c.cloudfront.net/uploads/' . $data[0]['img'];
        } else {
            return '';
        }
    }

    private function getImages($ids = array())
    {
        $query = str_replace(
            'ovmdw_',
            TABLE_PREFIX,
            "SELECT
            OvMdW_termmeta.term_id,
            OvMdW_postmeta.meta_value
            FROM
            OvMdW_termmeta
            INNER JOIN OvMdW_posts ON OvMdW_posts.ID = OvMdW_termmeta.meta_value
            LEFT JOIN OvMdW_postmeta ON OvMdW_postmeta.post_id = OvMdW_posts.ID
            WHERE
            OvMdW_termmeta.meta_key = 'thumbnail_id' AND
            OvMdW_termmeta.term_id IN ( " . implode(',', $ids) . " ) AND
            OvMdW_postmeta.meta_key = '_wp_attached_file'"
        );
        $data = $this->db->plainQuery($query);
        for ($i = 0; $i < $data['cant_rows']; $i++) {
            $this->images[$data[$i]['term_id']] = 'https://d1u9bbhcasux7c.cloudfront.net/uploads/' . $data[$i]['meta_value'];
        }
        return;
    }

    private function getCategoriesMaster($extend = true)
    {
        $parents = [];
        $children = [];
        $query = str_replace(
            'ovmdw_',
            TABLE_PREFIX,
            "SELECT
        ovmdw_term_taxonomy.term_id,
        ovmdw_terms.slug,
        ovmdw_terms.`name` as description,
        ovmdw_term_taxonomy.parent,
        ovmdw_term_taxonomy.count
        FROM
        ovmdw_term_taxonomy
        INNER JOIN ovmdw_terms ON ovmdw_terms.term_id = ovmdw_term_taxonomy.term_id
        WHERE
        ovmdw_term_taxonomy.taxonomy = 'product_cat' AND
        ovmdw_term_taxonomy.parent = 0 AND
        ovmdw_term_taxonomy.count > 0
        GROUP BY
        ovmdw_term_taxonomy.term_id
        ORDER BY
        ovmdw_terms.`name` ASC"
        );

        $data = $this->db->plainQuery($query);
        // die($query);
        for ($i = 0; $i < $data['cant_rows']; $i++) {
            $inactives = ($this->inactive_products[$data[$i]['term_id']] != '') ? $this->inactive_products[$data[$i]['term_id']] : 0;
            $data[$i]['count'] = $data[$i]['count'] - $inactives;
            array_push($parents, $data[$i]['term_id']);
        }

        if (count($parents) > 0) {
            $this->getImages($parents);
            if ($extend) {
                $children_dt = $this->getChildren($parents);
            } else {
                $children_dt = [];
            }

            for ($m = 0; $m < $children_dt['cant_rows']; $m++) {
                if (isset($children_dt[$m]['parent'])) {
                    $parent = $children_dt[$m]['parent'];
                    if (!is_array($children[$parent])) {
                        $children[$parent] = [];
                    }

                    array_push($children[$parent], $children_dt[$m]);
                }
            }
        }

        for ($i = 0; $i < $data['cant_rows']; $i++) {
            $data[$i]['children'] = [];

            if (isset($children[$data[$i]['term_id']])) {
                $data[$i]['children'] = $children[$data[$i]['term_id']];
            }
            $data[$i]['image'] = ($this->images[$data[$i]['term_id']] != '') ? $this->images[$data[$i]['term_id']] : '';
            array_push($this->categories, $data[$i]);
        }
        return $this;
    }

    private function getChildren($parent)
    {
        if (!is_array($parent) || empty($parent) || count($parent) == 0) {
            return array('cant_rows' => 0);
        }
        $parent_list = implode(',', array_unique($parent));
        $cats = [];
        $parents = [];
        $children = [];
        $query = sprintf(str_replace(
            'ovmdw_',
            TABLE_PREFIX,
            "SELECT
        ovmdw_term_taxonomy.term_id,
        ovmdw_terms.`name` as description,
        ovmdw_terms.slug,
        ovmdw_term_taxonomy.parent,
        ovmdw_term_taxonomy.count
        FROM
        ovmdw_term_taxonomy
        INNER JOIN ovmdw_terms ON ovmdw_terms.term_id = ovmdw_term_taxonomy.term_id
        WHERE
        ovmdw_term_taxonomy.parent in ( %s ) AND
        ovmdw_term_taxonomy.taxonomy = 'product_cat' AND
        ovmdw_term_taxonomy.count > 0
        GROUP BY
        ovmdw_term_taxonomy.term_id
        ORDER BY
        ovmdw_terms.`name` ASC"
        ), $parent_list);
        //echo $query;
        $data = $this->db->plainQuery($query);

        for ($i = 0; $i < $data['cant_rows']; $i++) {
            $inactives = ($this->inactive_products[$data[$i]['term_id']] != '') ? $this->inactive_products[$data[$i]['term_id']] : 0;
            $data[$i]['count'] = $data[$i]['count'] - $inactives;
            unset($data[$i]['inactives']);
            array_push($parents, $data[$i]['term_id']);
        }

        if (count($parents) > 0) {

            $children_dt = $this->getChildren($parents);

            for ($m = 0; $m < $children_dt['cant_rows']; $m++) {
                if (isset($children_dt[$m]['parent'])) {
                    $parent = $children_dt[$m]['parent'];
                    if (!is_array($children[$parent])) {
                        $children[$parent] = [];
                    }
                    array_push($children[$parent], $children_dt[$m]);
                }
            }
        }

        for ($i = 0; $i < $data['cant_rows']; $i++) {
            $data[$i]['children'] = [];
            if (isset($children[$data[$i]['term_id']])) {
                $data[$i]['children'] = $children[$data[$i]['term_id']];
            }
            array_push($cats, $data[$i]);
        }

        $cats['cant_rows'] = $data['cant_rows'];
        $this->current_level++;
        return $cats;
    }
}
