<?php


class  Colibri_class{

    private int|null $colibri_id = null;
    private string $user_id = '';
    private \collection $db;
    protected array $colibri = [
        "colibri_items" => [],
        "date" => "",
        "hash" => "",
        "id_colibri" => 0,
        "status" => 1
    ];
    private string|null $hash = '';
    private array $unavailable_products = [];


    public function __construct( $colibri_id = '' ) {
        $this->db = new collection();
        if($colibri_id == ''){
            $this->createColibri();
            $this->getColibriId();
            return;
        }
        $this->colibri_id = $colibri_id;
        return;
        
        
    }

    private function getColibriId(){
            $old_colibri = $this->db->searchForce('ng_colibri', [ 'status' => 1]);
            if ($old_colibri['cant_rows'] > 0) {
                $id_old_colibri = $old_colibri[0]['id_colibri'];
                $old_items_colibri = $this->db->searchForce('ng_colibri_items', ['colibri_id' => $id_old_colibri]);
                for ($i = 0; $i < $old_items_colibri['cant_rows']; $i++) {
                    $old_items_colibri[$i]['colibri_id'] = $this->colibri_id;
                    $this->insert($old_items_colibri[$i]);
                }
                //$this->destroy($this->hash);
            }
        return;

    }
    private function createColibri(){
        $this->colibri_id = $this->db->insert('ng_colibri', [ 'date' => date('Y-m-d H:i:s'), 'status' => 1]);
        //die(var_dump($this->colibri_id));
            return;

    }
    private function colibri_exists(): bool
    {

        $colibri_id = $this->db->searchForce('ng_colibri', [ 'status' => 1], limit: 1);
        if ($colibri_id['cant_rows'] > 0) {
            $this->colibri_id = $colibri_id[0]['id_colibri'];
            return true;
        }
        return false;
    }
    
    public function getProductInfo(): array
    {
        $products = new Products;
        $info=[];
        $list = $products->searchById(array_map(function ($item) {
            return $item['product_id'];
        }, $this->colibri['colibri_items']), true, true);
        foreach ($list as $value) {
            $info[$value['product_id']]=$value;
        }
        return $info;
    }
    public function insertMany(array $colibri_items): void
    {
        if (!$this->colibri_id) {
           // die("hola");
            $this->createColibri();
        }
        //die(var_dump($this));
        foreach ($colibri_items as $colibri_item){
            $item = $this->db->searchForce('ng_colibri_items', ['colibri_id' => $this->colibri_id, 'product_id' => $colibri_item['product_id'], 'variation_id' => $colibri_item['variation_id']], limit: 1);
            if ($item['cant_rows'] > 0) {
                $quantity = $colibri_item['quantity'] + $item[0]['quantity'];
                $this->update($colibri_item['product_id'], $quantity, $colibri_item['variation_id']);
            } else {
                $colibri_item['colibri_id'] = $this->colibri_id;
                $this->db->insert('ng_colibri_items', $colibri_item);
            }
        }
        return;
    }
    public function insert(array $colibri_item): void
    {
        if (!$this->colibri_id) {
            $this->createColibri();
        }
        $item = $this->db->searchForce('ng_colibri_items', ['colibri_id' => $this->colibri_id, 'product_id' => $colibri_item['product_id'], 'variation_id' => $colibri_item['variation_id']], limit: 1);
        if ($item['cant_rows'] > 0) {
            $quantity = $colibri_item['quantity'] + $item[0]['quantity'];
            $this->update($colibri_item['product_id'], $quantity, $colibri_item['variation_id']);
        } else {
            $colibri_item['colibri_id'] = $this->colibri_id;
            $this->db->insert('ng_colibri_items', $colibri_item);
        }
        return;
    }
    public function update(int|string  $product_id, int $value, int|string $variation_id): void
    {

        $where = ['colibri_id' => $this->colibri_id, 'product_id' => $product_id, 'variation_id' => $variation_id];
        $values = ['quantity' => $value];

        $this->db->update('ng_colibri_items', $where, $values);
    }
    public function destroy($colibri_id = '')
    {
        //die(var_dump($colibri_id));
        $this->disableColibri($colibri_id );
        return;
    }
    protected function disableColibri($colibri_id){
        if (isset($colibri_id) && $colibri_id == '') {
            throw new \Exception( "Colibri invalido", 400);
        } else {
            $where = [
                'colibri_id' => $this->colibri_id
            ];
        }
        $values = ['status' => 0];
        $this->db->update('ng_colibri', $where, $values);
        return;
    }
    public function getItems(bool $getStatus = false): array
    {

        if (!$this->colibri_id) {
            return $this->colibri;
        }
        //Asigna los productos de la base de datos al carrito temporal
        $this->getDatabasecolibriItems();

        //Si no hay productos no seguir
        if (count($this->colibri['colibri_items']) < 1) {
            return $this->colibri;
        }

        $list = [];
        //Obtener info de todos los productos temporales

        $all_products_info = $this->getProductInfo();
        //die(var_dump($all_products_info));
        foreach($this->colibri['colibri_items'] as $item){

            //Si no hay informacion para este producto, deshabilitalo
            if(!isset($all_products_info[$item['product_id']])){

                if ($getStatus && ($item['status'] == 1 || $item['status'] == "1")) {
                    $this->updateItemStatus($item['product_id'], $item['variation_id'], "0");
                    $this->unavailable_products[] = $item['product_id'];
                }
                continue;
            }

            //En caso de que haya informacion, ejectuta las siguientes comprobaciones:

                
            //Revisa si este item es un producto simple
            if(intval($item['variation_id']) == 0){

                //Asigna y guarda el producto
                $item['info'] = $all_products_info[$item['product_id']];
                $list[] = $item;

                //De ser necesario actualiza el estado
                if ($getStatus && ($item['status'] == 0 || $item['status'] == "0")) {
                    $this->updateItemStatus($item['product_id'], $item['variation_id'], "1");
                }

                continue;
            } 

            //Si se llego hasta aca es porque el item es hijo de un producto variable

            //Revisa si el variation id existe dentro del producto padre
            

            //Asigna y guarda el producto
            $item['info'] = $all_products_info[$item['product_id']];
            $list[] = $item;

            //De ser necesario actualiza el estado
            if ($getStatus && ($item['status'] == 0 || $item['status'] == "0")) {
                $this->updateItemStatus($item['product_id'], $item['variation_id'], "1");
            }

            
        }

        $this->colibri['colibri_items'] = $list;
        return $this->colibri;
    }
    private function getDatabasecolibriItems(): void
    {

        $where = ['colibri_id' => $this->colibri_id];
        $colibri_items = $this->db->search('ng_colibri_items', $where);

        $final_items['hash'] = $this->hash;
        foreach ($this->getColibriInfo() as $key => $val) {
            $final_items[$key] = $val;
        }

        if ($colibri_items < 1) {
            return;
        }
        $final_items['colibri_items'] = [];
        foreach ($colibri_items as $key => $colibri_item) {
            if ($key == 'cant_rows') {
                continue;
            }

            if (is_array($colibri_item)) {
                $final_items['colibri_items'][] = $colibri_item;
            }
        }

        $this->colibri = $final_items;
    }
    private function getColibriInfo(): array
    {

        $query = "SELECT *, DATEDIFF(NOW(), modified_at) as active_time FROM `ng_colibri` WHERE `colibri_id`= " . $this->db->sanitizeData($this->colibri_id) . "";
        $colibri_info = $this->db->plainQuery($query, force: true);

        if ($colibri_info['cant_rows'] < 1) {
            return [];
        }

        return $colibri_info[0];
    }
    private function updateItemStatus(int|string $product_id, int|string $variation_id, string $status): void
    {

        $where = ['colibri_id' => $this->colibri_id, 'product_id' => $product_id, 'variation_id' => $variation_id];
        $values = ['status' => $status];

        $this->db->update('ng_colibri_items', $where, $values);
    }

}