<?php

class dbclass
{
    private $mysqli;
    private $id;
    public function __construct()
    {
        //$this->mysqli = new mysqli(DB_HOST, DB_USER, DB_PASS, DB_NAME);
    }

    public function getUniqueId()
    {
        $it = explode(" ", microtime());

        $rt = str_pad(substr($it[1], -9) . str_replace(".", "", substr($it[0], 0, 7)), 16, rand(0, 9));
        return $rt;
    }
   
    public function xss_cleaner($input_str)
    {
        $return_str = str_replace(array('<',  '|', '>', "'", '"', ')', '('), array('&lt;', '&#124;', '&gt;', '&apos;', '&#x22;', '&#x29;', '&#x28;'), $input_str);
        $return_str = str_ireplace('%3Cscript', '', $return_str);
        return $return_str;
    }
    public function xss_reload($input_str)
    {
        $return_str = str_replace(array('&lt;', '&#124;',  '&gt;', '&apos;', '&#x22;', '&#x29;', '&#x28;'), array('<', '|',  '>', "'", '"', ')', '('), $input_str);
        return $return_str;
    }
    public function sanitize($arr)
    {
        if (is_array($arr)) {
            foreach ($arr as $key => $val) {
                $SanitizeData[$this->filterVarInput($this->xss_cleaner($key))] = $this->filterVarInput($this->xss_cleaner($val));
            }
            return $SanitizeData;
        } else {
            return $this->filterVarInput($this->xss_cleaner($arr));
        }
    }
    //devuelve el nombre de la primera columna en una tabla especifica
    public function get_id_name($table = 0)
    {
        $query_string = "SHOW COLUMNS FROM `" . $table . "`";
        $result = $this->execute_query($query_string);
        return ($result[0]['Field']);
    }
    //devuelve un array con las tablas diponibles en una DB
    public function get_tables()
    {
        $query_string = "SHOW TABLES";
        $result = $this->execute_query($query_string);
        return ($result);
    }
    // devuelve un array con los campos de una tabla

    public function getFieldsByTable($table = '')
    {
        $query_string = "SHOW COLUMNS FROM `" . $table . "`";
        $result = $this->execute_query($query_string);
        for ($i = 0; $i < $result['cant_rows']; $i++) {
            $campos[$i] = $result[$i]['Field'];
        }
        return ($campos);
    }
    public function execute_query($Query,$force=false)
    {
        try {
            $redis = new Redis();
            $key=md5($Query);
            //Connecting to Redis
            $redis->connect('redis', 6379);
            if(!$redis->get($key) || $force){
                $mysqli = new mysqli(DB_HOST, DB_USER, DB_PASS, DB_NAME,DB_PORT);
                $mysqli->set_charset('UTF8');
                if (DEBUG == 1) {
                    echo "<script>console.log('Executing: " . addslashes($Query) . "');</script>";
                }
                if (!$mysqli->connect_errno) {
                    $result = $mysqli->query($Query);
                    if ($result != false) {
                        if (DEBUG == 1) {
                            echo "<script>console.log('Ejecucion Exitosa');</script>";
                        }
                        $data= $this->prepareDataRead($result);
                        $redis->set($key, serialize($data));
                        $redis->expire($key, 120);
                        $source = 'mysql Server';
                        //echo $source . ': <br>';
                        $mysqli->close();
                        return $data;
                    }
                }
            }else{
                $source = 'Redis Server';
                //echo $source . ': <br>';
                return unserialize($redis->get($key));
            }
            
        } catch (Throwable $t) {
            try {
                $mysqli = new mysqli(DB_HOST, DB_USER, DB_PASS, DB_NAME,DB_PORT);
                    $mysqli->set_charset('UTF8');
                    if (DEBUG == 1) {
                        echo "<script>console.log('Executing: " . addslashes($Query) . "');</script>";
                    }
                    if (!$mysqli->connect_errno) {
                        $result = $mysqli->query($Query);
                        if ($result != false) {
                            if (DEBUG == 1) {
                                echo "<script>console.log('Ejecucion Exitosa');</script>";
                            }
                            $data= $this->prepareDataRead($result);
                            $mysqli->close();
                            return $data;
                        }
                    }
                
            } catch (Throwable $t) {
                //echo "Error No: " . $t->getCode() . " - " . $t->getMessage() . "<br >";
                //echo nl2br($t->getTraceAsString());
            }
        } catch (Exception $e) {
           // echo "Error No: " . $e->getCode() . " - " . $e->getMessage() . "<br >";
           // echo nl2br($e->getTraceAsString());
        }
    }
    public function execute_query_insert($Query)
    {
        try {
            $mysqli = new mysqli(DB_HOST, DB_USER, DB_PASS, DB_NAME,DB_PORT);
                $mysqli->set_charset('UTF8');
                if (DEBUG == 1) {
                    echo "<script>console.log('Executing: " . addslashes($Query) . "');</script>";
                }
                if (!$mysqli->connect_errno) {
                    $result = $mysqli->query($Query);
                    if ($result != false) {
                        $id = mysqli_insert_id($mysqli);
                        //$id= $mysqli->insert_id;
                        //die(var_dump($id));
                        $mysqli->close();
                        return $id;
                    }
                }
            
        } catch (Throwable $t) {
            //echo "Error No: " . $t->getCode() . " - " . $t->getMessage() . "<br >";
            //echo nl2br($t->getTraceAsString());
        }
    }

    public function execute_query_plain($Query)
    {
        try {
            $mysqli = new mysqli(DB_HOST, DB_USER, DB_PASS, DB_NAME);
            $mysqli->set_charset('UTF8');

            if (!$mysqli->connect_errno) {
                $result = $mysqli->query($Query);
                if ($result != false) {

                    return $this->prepareDataReadPlain($result);
                    $mysqli->close();
                }
            }
        } catch (Throwable $t) {
            echo "Error No: " . $t->getCode() . " - " . $t->getMessage() . "<br >";
            echo nl2br($t->getTraceAsString());
            die('no se ejecuto');
        } catch (Exception $e) {
            echo "Error No: " . $e->getCode() . " - " . $e->getMessage() . "<br >";
            echo nl2br($e->getTraceAsString());
            die('no se ejecuto');
        }
    }

    public function prepareDataReadPlain($result)
    {
        $row = 0;
        //var_dump($result);
        if ($result != false) {
            while ($data = $result->fetch_array(MYSQLI_ASSOC)) {
                foreach ($data as $k => $vk) {
                    $arr_data[$row][$k] = $vk;
                }
                $row++;
            }
            $arr_data['cant_rows'] = $result->num_rows;
        } else {
            $arr_data['cant_rows'] = 0;
        }
        return $arr_data;
    }

    public function execute_query_void($Query)
    {
        try {
            $mysqli = new mysqli(DB_HOST, DB_USER, DB_PASS, DB_NAME,DB_PORT);
            $mysqli->set_charset('UTF8');
            if (DEBUG == 1) {
                echo "<script>console.log('Executing: " . addslashes($Query) . "');</script>";
            }
            if (!$mysqli->connect_errno) {
                $result = $mysqli->query($Query);
                if ($result != false) {
                    if (DEBUG == 1) {
                        echo "<script>console.log('Ejecucion Exitosa');</script>";
                    }
                    $mysqli->close();
                }
            }
        } catch (Throwable $t) {
            echo "Error No: " . $t->getCode() . " - " . $t->getMessage() . "<br >";
            echo nl2br($t->getTraceAsString());
            die('no se ejecuto');
        } catch (Exception $e) {
            echo "Error No: " . $e->getCode() . " - " . $e->getMessage() . "<br >";
            echo nl2br($e->getTraceAsString());
            die('no se ejecuto');
        }
    }
    public function filterVarInput($var)
    {
        $varf = addslashes($this->xss_cleaner($var));
        return utf8_encode(utf8_decode($varf));
    }
    public function filterVarRead($var)
    {
        return $this->xss_reload(stripslashes(utf8_decode(utf8_encode($var))));
    }
    public function get_array_tb($tabla, $data, $indexExclude = true)
    {
        $campos = $this->getFieldsByTable($tabla);
        $arr_data = array();
        foreach ($data as $k => $vk) {
            if ($indexExclude) {
                if ($k != $campos[0]) {
                    if (in_array($k, $campos, true)) {
                        $arr_data[$k] = $vk;
                    }
                }
            } else {
                if (in_array($k, $campos??[], true)) {
                    $arr_data[$k] = $vk;
                }
            }
        }
        return ($arr_data);
    }
    public function prepareDataRecord($table, $data, $indexExclude = true)
    {
        if (isset($data) && is_array($data)) {
            $index = $this->get_id_name($table);
            $fields = $this->get_array_tb($table, $data, $indexExclude);
            foreach ($fields as $key => $val) {
                if ($indexExclude) {
                    if ($key != $index) {
                        $prepareData[$key] = $this->filterVarInput($this->xss_cleaner($val));
                    }
                } else {
                    $prepareData[$key] = $this->filterVarInput($this->xss_cleaner($val));
                }
            }
            if (DEBUG == 1) {
                echo "<script>console.log('prepare " . json_encode($prepareData) . "')</script>";
            }
            return $prepareData;
        } else {
            die();
        }
    }
    public function prepareDataRead($result)
    {
        $row = 0;
        //var_dump($result);
        if ($result != false) {
            while ($data = $result->fetch_array(MYSQLI_ASSOC)) {
                foreach ($data as $k => $vk) {
                    $arr_data[$row][$k] = $this->filterVarRead($vk);
                }
                $row++;
            }
            $arr_data['cant_rows'] = $result->num_rows;
        } else {
            $arr_data['cant_rows'] = 0;
        }
        return $arr_data;
    }
    public function reset_data_param($table = 0, $param = array())
    {
        $where = "1=1 ";
        $campos = array_keys($param);
        if (is_array($param)) {
            for ($i = 0; $i < count($param); $i++) {
                $where .= "AND " . $campos[$i] . " = '" . $param[$campos[$i]] . "'";
            }
        }
        $query_string = "DELETE FROM " . $table . " WHERE (" . $where . ")";
        $mysqli = new mysqli(DB_HOST, DB_USER, DB_PASS, DB_NAME);
        $result = $this->execute_query_void($query_string, $mysqli);
        return;
    }
    /**
     * @param $filter String DEFAULT_WHERE / INIT_LIKE / END_LIKE / BOTH_LIKE
     */
    public function prepareWhere($vars, $equal = 'AND', $filter = 'DEFAULT_WHERE', $table)
    {
        if (DEBUG == 1) {
            echo "<script>console.log('TYPE Text: " . $equal . "')</script>";
        }
        $campo = array();
        $valor = array();
        //var_dump($vars);
        foreach ($vars as $k => $vk) {
            $campo[] = $k;
            $valor[] = $vk;
        }
        $where = '';
        switch ($filter) {
            case 'DEFAULT_WHERE':
                for ($d = 0; $d < count($campo); $d++) {
                    if ($where == '') {
                        $where = "`" . $table . "`.`" . $campo[$d] . "`='" . $valor[$d] . "'";
                    } else {
                        $where .= " " . $equal . " `" . $table . "`.`" . $campo[$d] . "` ='" . $valor[$d] . "'";
                    }
                }
                break;
            case 'INIT_LIKE':
                for ($d = 0; $d < count($campo); $d++) {
                    if ($where == '') {
                        $where = "`" . $campo[$d] . "` LIKE '%" . $valor[$d] . "'";
                    } else {
                        $where .= " " . $equal . " " . $campo[$d] . " LIKE '%" . $valor[$d] . "'";
                    }
                }
                break;
            case 'END_LIKE':
                for ($d = 0; $d < count($campo); $d++) {
                    if ($where == '') {
                        $where = "`" . $campo[$d] . "` LIKE '" . $valor[$d] . "%'";
                    } else {
                        $where .= " " . $equal . " `" . $campo[$d] . "` LIKE '" . $valor[$d] . "%'";
                    }
                }
                break;
            case 'BOTH_LIKE':
                for ($d = 0; $d < count($campo); $d++) {
                    if ($where == '') {
                        $where = "`" . $campo[$d] . "` LIKE '%" . $valor[$d] . "%'";
                    } else {
                        $where .= " " . $equal . " `" . $campo[$d] . "` LIKE '%" . $valor[$d] . "%'";
                    }
                }
                break;
            default:
                for ($d = 0; $d < count($campo); $d++) {
                    if ($where == '') {
                        $where = "`" . $campo[$d] . "`='" . $valor[$d] . "'";
                    } else {
                        $where .= " " . $equal . " `" . $campo[$d] . "` ='" . $valor[$d] . "'";
                    }
                }
                break;
        }
        if (DEBUG == 1) {
            echo "<script>console.log('WHERE Text: " . addslashes($where) . "')</script>";
        }
        return $where;
    }
}