<?php

class search
{

    private $result;
    private $table;
    private $idField;
    private $show = array();
    private $fields = array();
    private $filter = array();
    private $where = array();
    private $having = array();
    private $stack;
    private $order = array();
    private $limit;
    private $mixed;
    private $query;
    private $queryC;

    public function __construct($table = '')
    {
        $this->stack = new collection;
        if ($table != '') {
            $this->table($table);
            $this->idField = $this->stack->getIdField($table);
            $this->limit('1000');
        }
    }

    public function prepareQuery($query = '')
    {

        if ($query != '') {
            $this->query = $query;
            $this->query .= " WHERE 1=1 ";
            if (count($this->fields) >= 1 && count($this->filter) >= 1) {
                $this->query .= "AND MATCH (`" . implode('`,`', $this->fields) . "`) ";
                $this->query .= "AGAINST ('" . implode(' ', $this->filter) . "' IN BOOLEAN MODE) ";
            }
            if (count($this->where) >= 1) {
                $this->query .= "AND " . implode(' AND ', $this->where) . " ";
            }
            if (count($this->having) >= 1) {
                $this->query .= "HAVING " . implode(' AND ', $this->having) . " ";
            }
            $this->query .= "ORDER BY " . implode(', ', $this->order) . " ";
            $this->query .= "LIMIT " . $this->limit . " ";
        } else {
            $this->query = 'SELECT ';
            if (count($this->fields) >= 1 && count($this->filter) >= 1) {
                $this->query .= "MATCH (`" . implode('`,`', $this->fields) . "`) AGAINST ('" . implode(' ', $this->filter) . "' IN BOOLEAN MODE) as relevance,";
            }
            $this->query .= "`" . $this->table . "`.* ";
            $this->query .= "FROM `" . $this->table . "` ";
            $this->query .= "WHERE 1=1 ";
            if (count($this->fields) >= 1 && count($this->filter) >= 1) {
                $this->query .= "AND MATCH (`" . implode('`,`', $this->fields) . "`) ";
                $this->query .= "AGAINST ('" . implode(' ', $this->filter) . "' IN BOOLEAN MODE) ";
            }
            if (count($this->where) >= 1) {
                $this->query .= "AND " . implode(' AND ', $this->where) . " ";
            }
            if (count($this->having) >= 1) {
                $this->query .= "HAVING " . implode(' AND ', $this->having) . " ";
            }
            $this->query .= "ORDER BY " . implode(', ', $this->order) . " ";
            $this->query .= "LIMIT " . $this->limit . " ";
        }
        return $this;
    }
    private function prepareQueryCount()
    {
        $this->queryC = 'SELECT  ';
        $this->queryC .= "COUNT(`" . $this->idField . "`) AS count ";
        $this->queryC .= "FROM `" . $this->table . "` ";
        $this->queryC .= "WHERE 1=1 ";

        if (count($this->fields) >= 1 && count($this->filter) >= 1) {
            $this->queryC .= "AND MATCH (`" . implode('`,`', $this->fields) . "`) ";
            $this->queryC .= "AGAINST ('" . implode(' ', $this->filter) . "' IN BOOLEAN MODE) ";
        }
        if (count($this->where) >= 1) {
            $this->queryC .= "AND " . implode(' AND ', $this->where) . " ";
        }
        if (count($this->having) >= 1) {
            $this->queryC .= "HAVING " . implode(' AND ', $this->having) . " ";
        }
    }

    public function execute()
    {
        $this->prepareQuery($this->mixed);
        $this->prepareQueryCount();
        $this->run();
        return $this->result;
    }

    public function executeMixed()
    {
        $this->run();
        return $this->result;
    }

    public function print()
    {
        echo $this->query;
    }

    public function executeSelected($fields = array())
    {
        $this->prepareQuery($this->mixed);
        $this->prepareQueryCount();
        $this->run();
        $this->selected($fields);
        return $this->result;
    }

    private function selected($fields = array())
    {
        foreach ($fields as $key => $value) {
            for ($i = 0; $i < $this->result['cant_rows']; $i++) {
                //$this->result[$i] = array_intersect_key($fields, $this->result[$i]);
                $resultSelected[$i][$value] = $this->result[$i][$value];
            }
        }
        $resultSelected['cant_rows'] = $this->result['cant_rows'];
        $resultSelected['count'] = $this->result['count'];

        $this->result = $resultSelected;

        return $this;
    }

    public function debug($bool = true)
    {
        if ($bool) {
            $this->prepareQuery($this->mixed);
            $this->prepareQueryCount();
        }
        echo $this->query;
        return $this;
    }

    public function run()
    {
        $this->result = $this->stack->plainQuery($this->query);
        $count = $this->stack->plainQuery($this->queryC);
        $this->result['count'] = $count[0]['count'];
        return $this;
    }

    public function table($table)
    {
        $this->table = $table;
        return $this;
    }
    public function search($text, $min_length = 0)
    {

        if (is_array($text)) {
            foreach ($text as $key => $value) {
                if ($min_length == 0 || strlen($value) >= $min_length) {
                    $this->filter[] = $this->stack->sanitizeData($value) . '*';
                }
            }
        } else {
            if ($text != '') {
                $t = explode(' ', $text);
                foreach ($t as $key => $value) {
                    if ($min_length == 0 || strlen($value) >= $min_length) {
                        $this->filter[] = $this->stack->sanitizeData($value) . '*';
                    }
                }
            }
        }
        return $this;
    }
    public function in($fields)
    {
        if (is_array($fields)) {
            foreach ($fields as $key => $value) {
                $this->fields[] = $value;
            }
        } else {
            if ($fields != '') {
                $this->fields[] = $fields;
            }
        }
        return $this;
    }

    public function having($having)
    {
        if (is_array($having)) {
            foreach ($having as $key => $value) {
                $this->having[] = $key . "='" . $this->stack->sanitizeData($value) . "'";
            }
        }
        return $this;
    }

    public function where($where)
    {
        if (is_array($where)) {
            foreach ($where as $key => $value) {
                $this->where[] = $key . "='" . $this->stack->sanitizeData($value) . "'";
            }
        }
        return $this;
    }
    public function whereLike($where)
    {
        if (is_array($where)) {
            foreach ($where as $key => $value) {
                $this->where[] = $key . " LIKE '" . $this->stack->sanitizeData($value) . "%'";
            }
        }
        return $this;
    }
    public function inRange($where, $init = '', $end = '')
    {
        if (!is_array($where)) {
            if ($end == '' && $init != '') {
                $this->where[] = $where . " >= '" . $this->stack->sanitizeData($init) . "'";
            } else if ($end != '' && $init == '') {
                $this->where[] = $where . " <= '" . $this->stack->sanitizeData($end) . "'";
            } else if ($end != '' && $init != '') {
                $this->where[] = $where . " BETWEEN '" . $this->stack->sanitizeData($init) . "' AND '" . $this->stack->sanitizeData($end) . "'";
            }
        }
        return $this;
    }
    public function by($order)
    {
        if (is_array($order)) {
            foreach ($order as $key => $value) {
                $this->order[] = $this->stack->sanitizeData($value);
            }
        } else {
            $this->order[] = $this->stack->sanitizeData($order);
        }
        return $this;
    }
    public function limit($limit)
    {
        $this->limit = $limit;
        return $this;
    }
    public function show($show)
    {
        $this->show = $show;
        return $this;
    }
    public function mixed($query)
    {
        $this->mixed = $query;
        return $this;
    }
}