<?php

class Destination
{


    public $db;
    public $alias = '';
    public $first_name = '';
    public $last_name = '';
    public $company = '';
    public $address_1 = '';
    public $address_2 = '';
    public $city = '';
    public $postcode = '';
    public $country = '';
    public $company_id = '';
    public $state = '';
    public $email = '';
    public $phone = '';
    public $delivery_status = false;
    public $billing_status = false;
    public $billing_company_status = false;

    /***
     * 
     * create new object Destination from Json-Array Object
     */
    public function __construct(array $json)
    {
        if (!isset($json) || !is_array($json)) {
            throw new Exception("Error al procesar la dirección", 1);
        }
        $this->db = new collection();
        $this->fromArray($json);
    }

    

    public function toArray()
    {
        return array(
            'alias' => $this->alias,
            'first_name' => $this->first_name,
            'last_name' => $this->last_name,
            'company' => $this->company,
            'address_1' => $this->address_1,
            'address_2' => $this->address_2,
            'city' => $this->city,
            'postcode' => $this->postcode,
            'country' => $this->country,
            'state' => $this->state,
            'email' => $this->email,
            'phone' => $this->phone,
            'delivery_status' => $this->delivery_status,
            'billing_status' => $this->billing_status,
            'company_id' => $this->company_id,
            'billing_company_status' => $this->billing_company_status,
        );
    }

    public function fromArray($data)
    {
        if ($data === null) {
            throw new Exception("Error al procesar la dirección", 1);
        }
        $arg = $data;
        $this->alias = ($arg['alias']!=null)?$arg['alias']: $this->alias;
        $this->first_name = ($arg['first_name']!=null)?$arg['first_name']: $this->first_name;
        $this->last_name = ($arg['last_name']!=null)?$arg['last_name']: $this->last_name;
        $this->company = ($arg['company']!=null)?$arg['company']: $this->company;
        $this->address_1 = ($arg['address_1']!=null)?$arg['address_1']: $this->address_1;
        $this->address_2 = ($arg['address_2']!=null)?$arg['address_2']: $this->address_2;
        $this->city = ($arg['city']!=null)?$arg['city']: $this->city;
        $this->postcode = ($arg['postcode']!=null)?$arg['postcode']: $this->postcode;
        $this->country = ($arg['country']!=null)?$arg['country']: $this->country;
        $this->state = ($arg['state']!=null)?$arg['state']: $this->state;
        $this->email = ($arg['email']!=null)?$arg['email']: $this->email;
        $this->phone = ($arg['phone']!=null)?$arg['phone']: $this->phone;
        $this->delivery_status = ($arg['delivery_status']!=null)?$arg['delivery_status']: $this->delivery_status;
        $this->billing_status = ($arg['billing_status']!=null)?$arg['billing_status']: $this->billing_status;
        $this->company_id = ($arg['country_id']!=null)?$arg['country_id']: $this->company_id;
        $this->billing_company_status = ($arg['billing_company_status']!=null)?$arg['billing_company_status']: $this->billing_status;
    }

    public function get_full_name()
    {
        return $this->first_name.' '.$this->last_name;
    }

    public function get_countryCode()
    {
        $dt = $this->db->search('bi_country_table',array('country_name'=>$this->country));
        return $dt[0]['country_tag']??'';
    }

    
}


