<?php

class DHL_class implements Currier
{
    private $url = DHL_URL;
    private $apiKey = DHL_ACCESS_KEY;
    private $apiSecret = DHL_ACCESS_SECRET;
    private $accountType = DHL_ACCOUNT_TYPE;
    private $accountNumber = DHL_ACCOUNT_NUMBER;
    private $productCode = 'P';
    private $isCustomsDeclarable = true;
    private $getRateEstimates = true;
    private $pickupDelay = '+1 day';

    private $currentDate;
    private $pickupDate;
    private $currentDateString;
    private $pickupDateString;
    private $request = '';
    public $error = '';
    public $response = [];
    private $request_id;
    public $packingList = [];
    private $senderData = [];
    private $customerData = [];
    private $packageData = [];
    private Package $package;
    private $_tracking_document = '';
    private $_shipmentTrackingNumber = '';
    private $_shipmentPickUpDate = '';
    public $status=true;
    private $errorcodes=['1001'=>'El los producto(s) solicitado(s) no está(n) disponible(s) según los criterios de búsqueda.',
    '1003'=>'Servicio de recogida no disponible en este día.',
    '1004'=>'Producto no disponible entre este origen y destino.',
    '340001'=>'No se pudo encontrar el código de país de origen. Por favor, comprueba el código de país.',
    '340002'=>'No se pudo encontrar el código de país de destino. Por favor, comprueba el código de país.',
    '340003'=>'No se pudo encontrar el código de país de pago.',
    '340004'=>'Falta información de ubicación. Se debe proporcionar al menos un atributo de código postal, nombre de ciudad o nombre de suburbio.',
    '340005'=>'Productos disponibles eliminados por filtro de marketing.',
    '340006'=>'Falta la hora de preparación. Este es un parámetro obligatorio.',
    '340007'=>'No se pudo encontrar el código de mercancía, por favor comprueba el código de mercancía.',
    '340008'=>'Falta el peso de la pieza. Esta es una información obligatoria.',
    '340009'=>'Falta el número de piezas.',
    '340010'=>'Falta el volumen total del envío.',
    '340011'=>'Falta el peso máximo de la pieza.',
    '340012'=>'Falta la altura máxima de la pieza.',
    '340013'=>'Falta la longitud máxima de la pieza.',
    '340014'=>'Falta el ancho/diámetro máximo de la pieza.',
    '340015'=>'Falta el valor declarado.',
    '340016'=>'El tipo de pieza es inválido.',
    '340017'=>'Falta la unidad de peso.',
    '340018'=>'El valor declarado no puede exceder el límite establecido para el país.',
    '340019'=>'Unidad de medida de peso desconocida.',
    '340020'=>'Unidad de medida de dimensiones desconocida.',
    '340021'=>'Falta la moneda.',
    '340022'=>'El peso máximo de la pieza es mayor que el peso total del envío.',
    '340023'=>'Símbolo de moneda desconocido.',
    '340024'=>'Falta el código de producto(s) global(es) o local(es).',
    '340025'=>'Falta el código de servicio(s) global(es) o local(es).',
    '340026'=>'Combinación inválida de unidades de peso y dimensiones.',
    '340027'=>'Combinación de servicio y producto inválida.',
    '340028'=>'Falta la unidad de medida.',
    '340029'=>'La unidad de medida debe ser la misma para todas las dimensiones.',
    '340030'=>'Código genérico de criterio desconocido.',
    '340031'=>'El formato de las dimensiones no es correcto. Por favor, comprueba el formato de las dimensiones.',
    '340032'=>'El formato del peso no es correcto. Por favor, comprueba el formato del peso.',
    '340033'=>'Formato de hora de preparación inválido.',
    '340035'=>'Falta la unidad de dimensiones.',
    '340036'=>'La fecha de salida debe tener el formato AAAA-MM-DD.',
    '340038'=>'Si VLDPICKUP = N en la solicitud, la fecha',
    '340038'=>'Si VLDPICKUP = N establecido en la solicitud, entonces la Fecha de salida de la instalación debe ser parte de la solicitud.',
    '340039'=>'Si VLDPICKUP = Y establecido en la solicitud, entonces la Fecha de salida de la instalación NO debe ser parte de la solicitud.',
    '340040'=>'Los únicos operadores permitidos son \'eq\': igual, \'ge\': mayor o igual, \'gt\': mayor que.',
    '410101'=>'El peso del envío supera el máximo.',
    '410102'=>'La altura del envío supera el máximo.',
    '410103'=>'La longitud del envío supera el máximo.',
    '410104'=>'El ancho/diámetro del envío supera el máximo.',
    '410105'=>'El/los producto(s) solicitado(s) no está(n) disponible(s).',
    '410106'=>'El peso de la pieza supera el máximo.',
    '410107'=>'La altura de la pieza supera el máximo.',
    '410108'=>'La longitud de la pieza supera el máximo.',
    '410109'=>'El ancho/diámetro de la pieza supera el máximo.',
    '410110'=>'El peso del envío es inferior al mínimo.',
    '410111'=>'La altura del envío es inferior al mínimo.',
    '410112'=>'La longitud del envío no está dentro de las restricciones.',
    '410113'=>'El ancho/diámetro del envío es inferior al mínimo.',
    '410114'=>'No se ha alcanzado la dimensión mínima de la pieza.',
    '410115'=>'No se ha alcanzado la dimensión media de la pieza.',
    '410116'=>'No se ha alcanzado la dimensión máxima de la pieza.',
    '410117'=>'No se cumple con el peso mínimo de la pieza.',
    '410118'=>'Se ha superado el número de piezas permitido.',
    '410119'=>'No se ha alcanzado la dimensión mínima del envío.',
    '410120'=>'No se ha alcanzado la dimensión media del envío.',
    '410121'=>'No se ha alcanzado la dimensión máxima del envío.',
    '410122'=>'No se cumple con el peso mínimo del envío.',
    '410123'=>'Se ha superado el valor declarado máximo del envío.',
    '410124'=>'Se ha aplicado una regla de mercado geográfico.',
    '410125'=>'No se cumple con el valor monetario mínimo de entrada.',
    '410126'=>'Se ha superado el valor monetario máximo de entrada.',
    '410127'=>'No se cumple con el número mínimo de piezas.',
    '410128'=>'No se cumple con el valor monetario mínimo de salida.',
    '410129'=>'Se ha superado el valor monetario máximo de salida.',
    '410130'=>'No se cumple con el número mínimo de paletas.',
    '410131'=>'Se ha superado el número máximo de paletas.',
    '410132'=>'No se cumple con el peso mínimo de la paleta.',
    '410133'=>'Se ha superado el peso máximo de la paleta.',
    '410134'=>'La dimensión máxima (longitud; ancho; altura)',
    '410138'=>'Producto(s) solicitado(s) no disponible(s) en el pagador <lista de productos globales/locales separados por ", ">',
    '410139'=>'Producto(s) solicitado(s) disponible(s) solo con acuerdo contractual <lista de productos globales/locales separados por ", ">',
    '410140'=>'Producto(s) solicitado(s) no disponible(s) en la red requerida <lista de productos globales/locales separados por ", ">',
    '410201'=>'El servicio de recogida no se proporciona en este día.',
    '410202'=>'La fecha de recogida está fuera de la ventana deslizante: fechaDesde-fechaHasta',
    '410203'=>'La hora de preparación está fuera de la ventana de recogida',
    '410301'=>'Producto no disponible entre este origen y destino (segmento de red).',
    '410302'=>'Cambio temporal de destino de red',
    '410303'=>'Productos disponibles eliminados por filtrado de comercialización',
    '410304'=>'No hay productos disponibles',
    '410501'=>'Se aplicó la regla de ambigüedad de PL de recogida. Hay más de 1 PL disponible para los atributos de PL dados.',
    '410502'=>'Se aplicó la regla de reemplazo de PL de recogida: PS->CP',
    '410503'=>'Se aplicó la regla de reemplazo de PL de recogida: PS->CP->P',
    '410504'=>'Se aplicó la regla de reemplazo de PL de recogida: PS->CP->P->C',
    '410505'=>'Se aplicó la regla de reemplazo de PL de recogida: CP->P',
    '410506'=>'Se aplicó la regla de reemplazo de PL de recogida: CP->P->C',
    '410507'=>'Se aplicó la regla de reemplazo de PL de recogida: P->C',
    '410508'=>'Se aplicó la regla de reemplazo de PL de recogida: S->C',
    '410509'=>'Se aplicó la regla de ambigüedad de PL de entrega. Hay más de 1 PL disponible para los atributos de PL dados.',
    '410510'=>'Se aplicó la regla de reemplazo de PL de entrega: PS->CP',
    '410511'=>'Se aplicó la regla de reemplazo de PL de entrega: PS->CP->P',
    '410512'=>'Se aplicó la regla de reemplazo de PL de entrega: PS->CP->P->C',
    '410513'=>'Se aplicó la regla de reemplazo de PL de entrega: CP->P',
    '410514'=>'Se aplicó la regla de reemplazo de PL de entrega: CP->P->C',
    '410515'=>'Se aplicó la regla de reemplazo de PL de entrega: P->C',
    '410517'=>'La instalación de origen está suspendida',
    '410518'=>'La instalación de destino está suspendida',
    '420501'=>'El código del país de origen no se pudo encontrar. Por favor, compruebe la página del país 127 DE 167',
    '420502'=>'El código del país de destino no se pudo encontrar. Por favor, compruebe el código del país.',
    '420503'=>'El código de país de pago no se pudo encontrar.',
    '420504'=>'La ubicación de origen es inválida. Por favor, revise los datos.',
    '420505'=>'La ubicación de destino es inválida. Por favor, revise los datos.',
    '420506'=>'Código postal no encontrado. Formatos esperados: <formato específico del país>.',
    '20001'=>'Ni el código de producto local ni el de red están presentes.',
    '20002'=>'El código del país de origen está ausente.',
    '20003'=>'El código de área de servicio de origen está ausente.',
    '20004'=>'El código del país de destino está ausente.',
    '20017'=>'Ni el código postal de destino ni el código de destino están presentes.',
    '30001'=>'Se ha superado la longitud máxima del código específico local.',
    '30002'=>'Formato de código postal inválido.',
    '40001'=>'No se encuentra el nombre corto del producto.',
    '40002'=>'No se encuentra el código de contenido del producto.',
    '40004'=>'No se encuentra el código de destino.',
    '50003'=>'Se han encontrado más de un código de área de servicio de destino.',
    '90001'=>'Error no clasificado.',
    '90002'=>'XML inválido.',
    '90003'=>'Error al acceder a la caché.',
    '99999'=>'Servidores GLS no disponibles.',
    '100002'=>'El ID de contenido de mercancías peligrosas solicitado no es válido. Por favor, actualice e inténtelo de nuevo.',
    '100002'=>'Falta el peso neto de hielo seco en la solicitud del contenido de mercancías peligrosas: 901. Por favor, actualice e inténtelo de nuevo.',
    '100002'=>'Falta el código UN en la solicitud del contenido de mercancías peligrosas: E01. Por favor, actualice e inténtelo de nuevo.',
    '400201'=>'Fallo durante la reserva.',
    '400202'=>'Campo(s) faltante(s).',
    '400203'=>'Se produjo un error al crear el archivo GNS521.',
    '400204'=>'Se produjo un error al cargar el archivo de manifiesto en el servidor FTP.',
    '400205'=>'Se produjo un error al transformar el resultado a XML.',
    '411402'=>'Tiempo de espera del consumidor de ShipmentManifest.',
    '998'=>'El campo \'ShipmentRequest/RequestedShipment/ShipmentInfo/PaperlessTradeImage\' es obligatorio cuando PaperlessTradeEnabled se establece en verdadero.',
    '998'=>'Se produjo un error en el proceso. ID de proceso asociado para esa transacción (9999999).',
    '100000'=>'La ejecución de la operación de servicio finalizó con éxito.',
    '100002'=>'Error de validación de datos del mensaje de solicitud de operación de servicio.',
    '100010'=>'Al solicitar detalles ePod se debe proporcionar el número de cuenta y el rol del cliente.',
    '7023'=>'El valor aduanero debe ser mayor que \'nivel de perfil de cliente\' - 0,01. Por favor, actualice el valor del campo ShipmentRequest/RequestedShipment/InternationalDetail/Commodities/CustomsValue'];



    public function __construct()
    {
        $this->currentDate = new DateTime();
        $this->currentDate->setTimeZone(new DateTimeZone('America/Panama'));
        $this->currentDateString = $this->currentDate->format('Y-m-d H:i:s');
        $this->setSenderData();
        //$this->generatePackageTotals(true);
    }

    private function setSenderData()
    {
        $this->setOriginData('shipperDetails', 'postalCode', '07097');
        $this->setOriginData('shipperDetails', 'cityName', 'colon');
        $this->setOriginData('shipperDetails', 'countryCode', 'PA');
        $this->setOriginData('shipperDetails', 'addressLine1', 'zona libre colon');
        /*$this->setOriginData('contactInformation', 'email', 'operaciones@bridgemarkets.com');
        $this->setOriginData('contactInformation', 'phone', '+5072018474');
        $this->setOriginData('contactInformation', 'mobilePhone', '+50762108489');
        $this->setOriginData('contactInformation', 'companyName', 'Bridgemarkets');
        $this->setOriginData('contactInformation', 'fullName', 'Carlos Fajardo');*/
    }

    public function setCustomerData(Destination $destitanion)
    {
        $this->setDestinationData('receiverDetails', 'postalCode', strval($destitanion->postcode));
        $this->setDestinationData('receiverDetails', 'cityName', $destitanion->city);
        $this->setDestinationData('receiverDetails', 'countryCode', $destitanion->get_countryCode());
        $this->setDestinationData('receiverDetails', 'addressLine1', $destitanion->address_1);
        /* $this->setDestinationData('contactInformation', 'email', $destitanion->email);
        $this->setDestinationData('contactInformation', 'phone', $destitanion->phone);
        $this->setDestinationData('contactInformation', 'companyName', $destitanion->company);
        $this->setDestinationData('contactInformation', 'fullName', $destitanion->get_full_name()); */
        return $this;
    }

    private function setNextBussinessDay(DateTime &$date)
    {
        $date->modify($this->pickupDelay);
        switch ($date->format('D')) {
            case 'Sat':
                $date->modify('+2 day');
                break;
            case 'Sun':
                $date->modify('+1 day');
                break;
            default:
                break;
        }
    }

    public function setOriginData($type, $key, $value)
    {
        switch ($type) {
            case 'postalAddress':
                $this->senderData[$type][$key] = $value;
                break;
            case 'contactInformation':
                $this->senderData[$type][$key] = $value;
                break;
            case 'typeCode':
                $this->senderData[$type] = $value;
                break;
            default:
            $this->senderData[$key] = $value;
                break;
        }
        return $this;
    }

    public function setDestinationData($type, $key, $value)
    {
        switch ($type) {
            case 'postalAddress':
                $this->customerData[$type][$key] = $value;
                break;
            case 'contactInformation':
                $this->customerData[$type][$key] = $value;
                break;
            case 'typeCode':
                $this->customerData[$type] = $value;
                break;
                default:
                $this->customerData[$key] = $value;
                break;
        }
        return $this;
    }

    private function createRequestBody()
    {
        $data['customerDetails']['shipperDetails'] = $this->senderData;
        $data['customerDetails']['receiverDetails'] = $this->customerData;
        $accounts['typeCode']=$this->accountType;
        $accounts['number']=$this->accountNumber;
        $data['accounts'][] =  $accounts;
        $data['productCode'] = $this->productCode;
        $data['plannedShippingDateAndTime'] = str_replace('@', 'GMT', $this->currentDate->format('Y-m-d\T09:00:00@P'));
        $data['isCustomsDeclarable'] = $this->isCustomsDeclarable;
        $data['unitOfMeasurement'] = "metric";
        $monetaryAmount['typeCode'] = "declaredValue";
        $monetaryAmount['value'] = $this->package->getTotalOrder();
        $monetaryAmount['currency'] = "USD";
        $data['monetaryAmount'][] =  $monetaryAmount;
        $data['nextBusinessDay'] = false;
        $data['productTypeCode'] = "all";
        $data['packages'] = $this->getPackages();
        return json_encode($data);
    }

    private function getPackages($extendedData = false)
    {
        $data = [];
        if ($extendedData) {
            /**
             * extended information
             */
        } else {
            foreach ($this->package->getItems() as $item) {
                if ($item instanceof PackageItem) {
                    for($i=0; $i < $item->get_quantity(); $i++){
                        array_push($data, array(
                            "weight" => $item->get_weight(),
                            "dimensions" => array(
                                "length" =>  $item->get_length(),
                                "width" => $item->get_width(),
                                "height" => $item->get_height()
                            )
                        ));
                    }
                }
            }
        }
        return $data;
    }
    public function export_shipping()
    {
    }

    public function import_shipping()
    {
    }
    public function errorResponse()
    {
        return [];
    }

    public function generateResponseSchema(Array $data, bool $include_taxes = false)
    {
        $res=[];
        if(!$data || empty($data) || empty($data['products'])){
            return $this->errorResponse();
        }
        $res['method_title']='DHL Express';
        $res['description']='DHL Express';
        $res['include_taxes'] = ($include_taxes)?'Incluye impuestos en destino':'No incluye impuestos en destino';
        $res['provider_image'] = 'https://bmbucket01.s3.ca-central-1.amazonaws.com/uploads/proveedores_logisticos/dhl.png';
        $res['message']='Los cargos arancelarios le serán comunicados en destino.';
        foreach($data['products'] as $product){
            $insurance=(($this->package->getTotalOrder()*0.01)>15)?($this->package->getTotalOrder()*0.01):15;
            $totalPrice=$product['totalPrice'][0]['price']+$insurance;
            $prod['type']='air';
            $prod['productName']=$product['productName'];
            $prod['totalPrice']['priceCurrency']=$product['totalPrice'][0]['priceCurrency'];
            $prod['totalPrice']['price']=round($totalPrice,2);
            $prod['volumetric']=$this->package->getTotalCBM();
            $prod['deliveryCapabilities']['totalTransitDays']=$product['deliveryCapabilities']['totalTransitDays'];
            //$prod['details'][]=$this->insertDetail('Impuesto de Nacionalización','Se calcularán en destino',0);
            $prod['details'][]=$this->insertDetail('Seguro de carga','',$insurance);
            $prod['details'][]=$this->insertDetail('Envío','',$product['totalPrice'][0]['price']);
            $res['options'][]=$prod;
            unset($prod);
        }
        return $res;
    }

    public function insertDetail($name='',$text='',$value='')
    {
        $dt['name']=$name;
        $dt['msg']=$text;
        $dt['value']=round($value,2);
        return $dt;
    }

    public function checkout_rate(Destination $destitanion, Package $package, bool $include_taxes)
    {
        $this->package = $package;
        $this->setCustomerData($destitanion);
        $responseCurl = new CurlRequest($this->apiKey,$this->apiSecret);
        $responseCurl->request($this->url.'rates','POST',$this->createRequestBody());
        if(!$responseCurl->status()){
            $this->status=false;
            $err=explode(':',$responseCurl->toObject()['detail']);
            $this->error=$this->errorcodes[$err[0]];
            return $this->errorResponse();
        }        
        return $this->generateResponseSchema($responseCurl->toObject(), $include_taxes);
    }
}
