<?php

class ZohoAuth
{

    private Collection $db;
    private string $module;
    private string $refresh_token;
    public string $access_token;

    public function __construct(string $module)
    {
        $this->db = new collection();
        $this->module = $module;
        $this->access_token = $this->getToken();
    }

    public function getToken(): string{

        $tokens = $this->db->plainQuery("SELECT *, TIMESTAMPDIFF(SECOND,created_at,NOW()) as diff FROM `ng_zoho` WHERE `scope` = '".$this->module."' ", false, true);

        if($tokens['cant_rows'] == 0){
            throw new Exception("No hay registros coincidentes", 1);
        }

        if($tokens[0]['diff'] > 3600){
            $this->refresh_token = $tokens[0]['refresh_token'];
            $this->setNewToken();
        } else {
            $this->access_token = $tokens[0]['access_token'];
        }

        return $this->access_token;

    }

    private function setNewToken(){

        $curl = new ZohoCurl;
        $curl->getTokenCode($this->refresh_token);

        if($curl->status()){

            $finalData = [
                'access_token'=> $curl->toObject()['access_token'],
            ];
    
            $this->db->update('ng_zoho', ['scope' => $this->module], $finalData);
            $this->access_token = $curl->toObject()['access_token'];
            
        } else {
            throw new Exception('Error al crear access token');
        }

        
    }


}