<?php
require('../../cfg.php');

if (true) {
    $requestMethod = $_SERVER["REQUEST_METHOD"];
    switch ($requestMethod) {
        case 'GET':
            try {
                if (isset($_GET['action']) && $_GET['action'] == 'all') {
                    $store = new Store();
                    $search = (isset($_GET['search']) && $_GET['search'] != '') ? $_GET['search'] : '';
                    $page = (isset($_GET['page']) && $_GET['page'] != '') ? $_GET['page'] : 1;
                    $count = (isset($_GET['count']) && $_GET['count'] != '') ? $_GET['count'] : 12;
                    $order = (isset($_GET['order']) && $_GET['order'] != '') ? filter_var( $_GET['order'], FILTER_VALIDATE_BOOLEAN) : false;
                    $data = $store->getAll($page, $count,$order);
                }

                if (isset($_GET['action']) && $_GET['action'] == 'searchByName') {
                    $store = new Store();
                    $search = (isset($_GET['search']) && $_GET['search'] != '') ? $_GET['search'] : '';
                    $page = (isset($_GET['page']) && $_GET['page'] != '') ? $_GET['page'] : 1;
                    $count = (isset($_GET['count']) && $_GET['count'] != '') ? $_GET['count'] : 12;
                    $order = (isset($_GET['order']) && $_GET['order'] != '') ? filter_var( $_GET['order'], FILTER_VALIDATE_BOOLEAN) : false;
                    $data = $store->searchByName($search, $page, $count, $order);
                }

                if (isset($_GET['action']) && $_GET['action'] == 'detailStore') {
                    $store = new Store();
                    $search = (isset($_GET['search']) && $_GET['search'] != '') ? $_GET['search'] : '';
                    $data = $store->detailStore($search);
                }

                if (isset($_GET['action']) && $_GET['action'] == 'highlights') {
                    $store = new Store();
                    $data = $store->getHighLights();
                }

                if (isset($_GET['action']) && $_GET['action'] == 'autocomplete') {
                    $store = new Store();
                    $search = (isset($_GET['search']) && $_GET['search'] != '') ? $_GET['search'] : '';
                    $count = 5;
                    $data = $store->autocomplete($search, $count);
                }

                if (isset($_GET['action']) && $_GET['action'] == 'searchByCat') {
                    $store = new Store();
                    $search = (isset($_GET['search']) && $_GET['search'] != '') ? $_GET['search'] : '';
                    $page = (isset($_GET['page']) && $_GET['page'] != '') ? $_GET['page'] : 1;
                    $count = (isset($_GET['count']) && $_GET['count'] != '') ? $_GET['count'] : 12;
                    $order = (isset($_GET['order']) && $_GET['order'] != '') ? filter_var( $_GET['order'], FILTER_VALIDATE_BOOLEAN) : false;
                    $data = $store->searchByCategory($search, $page, $count,$order);
                }

                if (isset($_GET['action']) && $_GET['action'] == 'getCategories') {
                    $store = new Store();
                    $data = $store->getStoreCategories();
                }
                if (isset($_GET['action']) && $_GET['action'] == 'FollowUpStore') {
                    $store = new Store();
                    $data = $store->followUp($_GET['store']);
                }
                if (isset($_GET['action']) && $_GET['action'] == 'FollowDownStore') {
                    $store = new Store();
                    $data = $store->followDown($_GET['store']);
                }
                if (isset($_GET['action']) && $_GET['action'] == 'FollowUpPage') {
                    $store = new Store();
                    $data = $store->getFollowUpStores();
                }
               

                if (!isset($data)) {
                    $data = [];
                }

                $rest = new RestResponse(true, $data);
                $rest->toJson()->setMessage('OK');
            } catch (\Throwable $th) {
                $rest = new RestResponse(false, $data);
                $rest->toJson()->setMessage($th->getMessage());
            }
            break;
        case 'POST':
            try {
                if (isset($_GET['action']) && $_GET['action'] == 'contact') {
                    $curl = new CurlRequest(API_USER, API_PASS);
                    
                    try {
                        $auth = new auth();
                        if ($auth->verify($auth->found())->status()) {
                            $user=$auth->getUser();
                            /* 
                            dokan-support-subject=prueba
                            dokan-support-msg=buscando%20ticket
                            store_id=804
                            dokan-support-form-nonce=77dbd9811d
                            _wp_http_referer=%2Fwp-admin%2Fadmin-ajax.php
                            user_id=804
                            */
                            $request = json_decode(file_get_contents("php://input"));
                            $postdata['dokan-support-subject']=$request->subject;
                            $postdata['dokan-support-msg']=$request->message;
                            $postdata['store_id']=$request->vendor_id;
                            $postdata['dokan-support-form-nonce']='77dbs9811d';
                            $postdata['user_id']=$auth->getUser();
                            $data_store['action']='dokan_support_ajax_handler';
                            $data_store['data']='support_msg_submit';
                            $data_store['form_data']=http_build_query($postdata,'',null, PHP_QUERY_RFC3986);
                            //die(print_r($data_store));
                            $curl = new CurlRequest(API_USER, API_PASS);

                            $curl->contentForm()->request($wp_api_root.'wp-admin/admin-ajax.php', 'POST', $data_store);
                            if($curl->status()){
                                $userData=new User($auth->getUser());
                                $Vendor=new Store();
                                
                                $vendorData=$Vendor->getStoreById($request->vendor_id);
                                $replace_vars = array(
                                    '{{title}}' => utf8_decode('Nueva consulta a comercio'),
                                    '{{datetime}}' => date('Y-m-d H:i:s'),
                                    '{{user_data}}' => $userData->first_name.' '.$userData->last_name.' | '.$userData->email.' | '.$userData->select_meta('profile_phone_code',$userData->meta_data).'-'.$userData->select_meta('profile_phone',$userData->meta_data),
                                    '{{storeName}}' => $vendorData[0]['dokan_store_name'],
                                    '{{content}}' => $request->message,
                                );
                                $email= new email();
                                $email->set_multidestination(CUSTOMERSERVICE_EMAIL_NOTIFICATIONS);
                                $email->load_template('Nueva consulta a comercio','email/customer_support_email');
                                $email->setReplace($replace_vars);
                                $email->send_mail();
                                $rest = new RestResponse(true, []);
                                $rest->toJson()->setMessage('¡Gracias. Tu ticket ha sido enviado!');
                            }else{
                                $rest = new RestResponse(false, []);
                                $rest->toJson()->setMessage('Error al realizar la solicitud');
                            }
                        }
                    } catch (\Throwable $th) {
                        $rest = new RestResponse(false, []);
                        $rest->toJson()->setMessage('Error al realizar la solicitud');
                    }
                    
                }
                if (isset($_GET['action']) && $_GET['action'] == 'comment') {
                    try {
                        $auth = new auth();
                        if ($auth->verify($auth->found())->status()) {
                            $user=$auth->getUser();
                            $request = json_decode(file_get_contents("php://input"));
                            $user = new User($auth->getUser());
                            $data['comment']=$request->message;
                            $data['comment_post_ID']=$request->ticket_id;
                            $data['comment_parent']=0;
                            $data['author']=$user->first_name.' ' .$user->last_name;
                            $data['_wp_unfiltered_html_comment']='f6f2cf5aef';
                            $curl = new CurlRequest(API_USER, API_PASS);
                                    /* 
                                comment: respuesta cliente
                                comment_post_ID: 30023
                                comment_parent: 0
                                author: Ronald Paredes 
                                _wp_unfiltered_html_comment: f6f2cf5aef 
                                */
                            $curl->contentForm()->request($wp_api_root.'wp-comments-post.php', 'POST', $data);
                            if($curl->status()){
                                $rest = new RestResponse(true, []);
                                $rest->toJson()->setMessage('¡Gracias. Tu mensaje ha sido enviado!');
                            }else{
                                $rest = new RestResponse(false, []);
                                $rest->toJson()->setMessage('Error al realizar la solicitud');
                            }
                        }
                    } catch (\Throwable $th) {
                        $rest = new RestResponse(false, []);
                        $rest->toJson()->setMessage('Error al realizar la solicitud '.$th->getMessage());
                    }
                }

                if (!isset($data)) {
                    $data = [];
                }
            } catch (\Throwable $th) {
                $rest = new RestResponse(false, $data);
                $rest->toJson()->setMessage($th->getMessage());
            }
            break;
        case 'PUT':

            break;
        case 'DELETE':

            break;
        default:


            break;
    }
}
if (!isset($rest) || !is_object($rest)) {
    $rest = new RestResponse(false, null);
    $rest->toJson()->setMessage('Acceso Restringido');
}
$rest->execute();
