<?php
require('cfg.php');
$auth = new auth();
if ($auth->verify($auth->found())->status()) {
    $requestMethod = $_SERVER["REQUEST_METHOD"];
    switch ($requestMethod) {
        case 'POST':
            switch ($_GET["action"]) {
                case 'add_address':
                    try {
                        $data = json_decode(file_get_contents("php://input"), true);
                        $id = $auth->getUser();
                        $user = new User($id);
                        unset($data['id']);
                        $addr_validation=$user->AddressValidation($data);
                        if(!$addr_validation['status']){
                            throw new Exception($addr_validation['response'], 42);
                            
                        }
                        $r = $user->setAddress($data);

                        if ($r) {
                            $rest = new RestResponse(true, $user->toArray());
                            $rest->toJson()->setMessage('OK');
                        } else {
                            $rest = new RestResponse(false, $user->toArray());
                            $rest->toJson()->setMessage('No se pudo ingresar la dirección');
                        }
                    } catch (\Throwable $th) {
                        $rest = new RestResponse(false, null);
                        $rest->toJson()->setMessage($th->getMessage());
                    }
                    break;
                case 'update_address':
                    try {
                        $data = json_decode(file_get_contents("php://input"), true);
                        $id = $auth->getUser();
                        $user = new User($id);
                        $addr_validation=$user->AddressValidation($data);
                        if(!$addr_validation['status']){
                            throw new Exception($addr_validation['response'], 42);
                            
                        }
                        $r = $user->updateAddress($data['id'], $data);

                        if ($r) {
                            $rest = new RestResponse(true, $user->toArray());
                            $rest->toJson()->setMessage('OK');
                        } else {
                            $rest = new RestResponse(false, $user->toArray());
                            $rest->toJson()->setMessage("No se pudo actualizar la dirección");
                        }
                    } catch (\Throwable $th) {
                        $rest = new RestResponse(false, null);
                $rest->toJson()->setMessage($th->getMessage());
                    }
                    break;
                case 'delete_address':
                    try {
                        $data = json_decode(file_get_contents("php://input"), true);
                        $id = $auth->getUser();
                        $user = new User($id);
                        $r = $user->deleteAddress($data['id']);

                        if ($r) {
                            $rest = new RestResponse(true, $user->toArray());
                            $rest->toJson()->setMessage('OK');
                        } else {
                            $rest = new RestResponse(false, $user->toArray());
                            $rest->toJson()->setMessage("No se pudo actualizar la dirección");
                        }
                    } catch (\Throwable $th) {
                        $rest = new RestResponse(false, null);
                $rest->toJson()->setMessage($th->getMessage());
                    }
                    break;
                default:
                    # code...
                    break;
            }
            break;
        case 'PUT':

            break;
        case 'DELETE':
            $data = json_decode(file_get_contents("php://input"));

            break;
    }
}
if (!isset($rest) || !is_object($rest)) {
    $rest = new RestResponse(false, null);
    $rest->toJson()->setMessage('Acceso Restringido');
}
$rest->execute();
