<?php

namespace BulkUpload\Handlers;

use BulkUpload\Error\ProductError;
use BulkUpload\Product as ProductObject;
use BulkUpload\Validation\Rules\Max;
use BulkUpload\Validation\Rules\NotEmpty;
use BulkUpload\Validation\Rules\Sku;
use \collection;

class Product extends ProductObject{

    private collection $db;
    private array $key_map;
    private int $vendor_id;

    public function __construct(bool $bulk_upload_product = false, string $bulk_upload_token = "", int $vendor_id)
    {

        $this->db = new collection;
        $this->vendor_id = $vendor_id;
        if($bulk_upload_product && $bulk_upload_product != ""){
            
            $this->setKeyMap($bulk_upload_product);

        }

    }

    private function validateProduct(array $product)//:ProductObject|ProductError
    {

        if(!isset($product[$this->key_map['id']])){
            
        }

        $notEmpty = new NotEmpty();

        $validatedProduct = [
            'name' => $notEmpty->linkRule(new Max(85))->validate($product[$this->key_map['name']], []),
            'slug' => $notEmpty->linkRule(new Max(85))->validate($product[$this->key_map['name']], []),
            'sku' => $notEmpty->linkRule(new Sku($this->vendor_id))
        ];

    }

    private function setKeyMap(string $token){

        $results = $this->db->searchForce("ng_bulk_upload_files", ['bulk_upload_id' => $token]);
        if($results['cant_rows'] > 0){
            $this->key_map = $results[0]['key_map'];
        }

    }

}