<?php

namespace BulkUpload\Interfaces;

use BulkUpload\Error\Error;
use Shuchkin\SimpleCSV;
use Shuchkin\SimpleXLS;
use Shuchkin\SimpleXLSX;

interface FileInterface {

    
    /**
     * Searchs the bulkToken in the database to return the data with the given purpose and extension.
     *
     * @param string $bulkToken
     * @param string $filePurpose
     * @param string $extension
     * @return array
     */
    public function getFile(string $bulkToken, string $filePurpose, string $extension, string $name):string|bool|Error;

    /**
     * Save the file data in the database, to be retrieved later in the required fileType. Retrieves true if the process is succesful.
     *
     * @param string $bulkToken
     * @param string $filePurpose
     * @param array $fileData
     * @param string $fileType
     * @return boolean
     */
    public function saveFile(string $bulkToken, string $filePurpose, array $fileData, string $fileType):bool;

}