<?php

namespace BulkUpload\Validation\Rules;

use BulkUpload\Validation\Rule;

class Max extends Rule{

    public array $errors = [];
    private int|float $max;

    public function __construct(int|float $max)
    {
        $this->max = $max;
    }

    public function validate(mixed $data, $errors){

        switch (gettype($data)) {
            case 'string':
                if(strlen(trim($data)) > $this->max){
                    array_push($this->errors, 'El valor ingresado no puede ser mayor a '.$this->max);
                }
                return parent::validate($data, array_merge($this->errors, $errors));

            case 'array':
                if(count($data) > $this->max){
                    array_push($this->errors, 'El valor ingresado no puede ser mayor a '.$this->max);
                }
                return parent::validate($data, array_merge($this->errors, $errors));
            case 'double':
                if($data > $this->max){
                    array_push($this->errors, 'El valor ingresado no puede ser mayor a '.$this->max);
                }
                return parent::validate($data, array_merge($this->errors, $errors));
            case 'integer':
                if($data > $this->max){
                    array_push($this->errors, 'El valor ingresado no puede ser mayor a '.$this->max);
                }
                return parent::validate($data, array_merge($this->errors, $errors));
        }

    }

}