<?php

namespace BulkUpload\Validation\Rules;

use BulkUpload\Validation\Rule;

class Min extends Rule{

    public array $errors = [];
    private int|float $min;

    public function __construct(int|float $min)
    {
        $this->min = $min;
    }

    public function validate(mixed $data, $errors){

        switch (gettype($data)) {
            case 'string':
                if(strlen(trim($data)) < $this->min){
                    array_push($this->errors, 'El valor ingresado no puede ser menor a '.$this->min);
                }
                return parent::validate($data, array_merge($this->errors, $errors));

            case 'array':
                if(count($data) < $this->min){
                    array_push($this->errors, 'El valor ingresado no puede ser menor a '.$this->min);
                }
                return parent::validate($data, array_merge($this->errors, $errors));
            case 'double':
                if($data < $this->min){
                    array_push($this->errors, 'El valor ingresado no puede ser menor a '.$this->min);
                }
                return parent::validate($data, array_merge($this->errors, $errors));
            case 'integer':
                if($data < $this->min){
                    array_push($this->errors, 'El valor ingresado no puede ser menor a '.$this->min);
                }
                return parent::validate($data, array_merge($this->errors, $errors));
        }

    }

}