<?php

class ProductFunctions extends products
{
    public function __construct()
    {
    }
    public function getData(string $key, array $cart_item)
    {
        if ($cart_item['variation_id'] == 0) {
            if ($cart_item['info'][$key]) {
                return $cart_item['info'][$key];
            } else {
                return null;
            }
        } else {
            foreach ($cart_item['variations'] as $variation) {
                if ($variation['product_id'] == $cart_item['variation_id']) {
                    if ($variation[$key]) {
                        return $cart_item[$key];
                    }
                }
            }
            if ($cart_item['info'][$key]) {
                return $cart_item['info'][$key];
            } else {
                return null;
            }
        }
    }

    public function getAttributes(array $cart_item)
    {
        $attr = [];
        if($cart_item['product_id'] != $cart_item['variation_id']){
            $atributes = $this->getData('attributes',$cart_item);
            if(isset($atributes) && is_array($atributes)){
                foreach ($atributes as $key => $value) {
                    $attr[]= $value['value'];
                }
                return implode(', ',$attr);
            }

        }
        return '';
    }


    public function getTotals(array $cart_items)
    {
        $total = 0;
        foreach ($cart_items as $item) {
            $moq = $this->getData('moq', $item);
            $price = $this->getCurrentPrice($item);
            $total += $item['quantity'] * $moq * $price;
        }
        return $total;
    }

    public function itemsTotal(array $cart_item)
    {
        $moq = $this->getData('moq', $cart_item);
        $price = $this->getCurrentPrice($cart_item);
        return  $cart_item['quantity'] * $moq * $price;
    }

    public function getTierOptions(array $cart_item)
    {
        return $this->getData('tier_options', $cart_item);
    }

    public function getCurrentPrice(array $cart_item)
    {
        $price = $this->getData('price', $cart_item);
        $moq = $this->getData('moq', $cart_item);
        $tiers = $this->getTierOptions($cart_item);
        if (is_array($tiers) && count($tiers) > 0) {
            foreach ($tiers as $tier) {
                if ($cart_item['quantity'] * $moq >= $tier['tier_qty']) {
                    $price = $tier['tier_price'];
                }
            }
        }
        return $price;
    }
}
