<?php

class TicketSupport
{
    private $user_id;
    private $db;
    private $list = [];
    private $id_list = [];
    private $full_list = [];
    private $vendors = [];

    public function __construct($user_id) {
        if(!isset($user_id) || empty($user_id)){
            throw new Exception("user id cant be null", 501);
            return false;
        }
        $this->user_id = $user_id;
        $this->db = new collection();
    }
    public function list($page = 1, $count = 10)
    {
        $this->getTickets($page, $count);
        $this->getMessages();
        $this->getVendorData();
        $this->compact();
        return array('tickets' => $this->list, 'count' => count($this->id_list));
    }

    private function compact(){
        foreach ($this->full_list as $key => $value) {
            if ($value['ticket_id'] != '') {
                array_push($this->list, $value);
            }
        }
    }

    private function vendorsId()
    {
        $query = str_replace(
            'ovmdw_',
            TABLE_PREFIX,
            "SELECT
            OvMdW_postmeta.meta_value as vendor_id,
            OvMdW_postmeta.post_id as ticket_id
            FROM
            OvMdW_postmeta
            WHERE
            OvMdW_postmeta.meta_key = 'store_id' AND
            OvMdW_postmeta.post_id IN (" . implode(",", array_keys($this->full_list)) . ")
        ");
        //die($query);
        $data = $this->db->plainQuery($query);
        for ($i = 0; $i < $data['cant_rows']; $i++) { 
            if($data[$i]['vendor_id']!=''){
                $this->vendors[$data[$i]['ticket_id']]=$data[$i]['vendor_id'];
            }   
        }
    }
    private function getVendorData()
    {
        $this->vendorsId();
        $query = str_replace(
            'ovmdw_',
            TABLE_PREFIX,
            "SELECT
        OvMdW_users.ID,
        OvMdW_users.user_nicename,
        OvMdW_usermeta.meta_value
        FROM
        OvMdW_users
        INNER JOIN OvMdW_usermeta ON OvMdW_usermeta.user_id = OvMdW_users.ID
        WHERE
        OvMdW_usermeta.meta_key = 'dokan_store_name' AND
        OvMdW_usermeta.user_id IN (" . implode(",", array_values($this->vendors)) . ")           
        "
        );
        //die($query);
        $data = $this->db->plainQuery($query);
        for ($i = 0; $i < $data['cant_rows']; $i++) {
            foreach ($this->vendors as $key => $value) {
                if (isset($this->full_list[$key]) && $value == $data[$i]['ID']) {
                    $this->full_list[$key]['vendor'] = $data[$i]['meta_value'];
                    $this->full_list[$key]['vendor_slug'] = $data[$i]['user_nicename'];
                    $this->full_list[$key]['vendor_id'] = $data[$i]['ID'];
                }
            }
        }
    }

    private function getMessages()
    {
        $query = "SELECT
        OvMdW_comments.comment_ID,
        OvMdW_comments.comment_post_ID,
        OvMdW_comments.comment_author,
        OvMdW_comments.comment_author_email,
        OvMdW_comments.comment_date,
        OvMdW_comments.comment_content,
        OvMdW_comments.user_id
        FROM
        OvMdW_comments
        WHERE
        OvMdW_comments.comment_post_ID IN (".implode(',',$this->id_list).")";
        //die($query);
        $data = $this->db->plainQuery($query);
        for ($i = 0; $i < $data['cant_rows']; $i++) {
            $key = $data[$i]['comment_post_ID'];
            if(isset($this->full_list[$key]['messages'])){
                array_push($this->full_list[$key]['messages'],array(
                    "comment_ID"=>$data[$i]['comment_ID'],
                    "comment_author"=>$data[$i]['comment_author'],
                    "comment_author_email"=>$data[$i]['comment_author_email'],
                    "comment_date"=>$data[$i]['comment_date'],
                    "comment_content"=>$data[$i]['comment_content'],
                    "user_id"=>$data[$i]['user_id'],
                ));
            }
            
        }
    }
    private function getTickets($page = 1, $count = 10)
    {
        $query = "SELECT
        OvMdW_posts.ID,
        OvMdW_posts.post_date,
        OvMdW_posts.post_content,
        OvMdW_posts.post_title,
        OvMdW_posts.comment_count,
        OvMdW_posts.post_status
        FROM
        OvMdW_posts
        WHERE
        OvMdW_posts.post_author = ".$this->user_id." AND
        OvMdW_posts.post_type = 'dokan_store_support'
        ORDER BY
        OvMdW_posts.ID DESC";
        
        $data = $this->db->plainQuery($query);
        for ($i = 0; $i < $data['cant_rows']; $i++) {
            $this->fillPrimaryList($data, $i);
        }
        $this->full_list = array_slice($this->id_list, ($page - 1) * $count, $count, true);
        $this->id_list = array_keys($this->id_list);
    }

    private function fillPrimaryList($data, $i)
    {
        $key = $data[$i]['ID'];
        $this->id_list[$key]['ticket_id'] = $data[$i]['ID'];
        $this->id_list[$key]['subject'] = $data[$i]['post_title'];
        $this->id_list[$key]['message'] = $data[$i]['post_content'];
        $this->id_list[$key]['status'] = $data[$i]['post_status'];
        $this->id_list[$key]['created_at'] = $data[$i]['post_date'];
        $this->id_list[$key]['comment_count'] = $data[$i]['comment_count'];
        $this->id_list[$key]['messages'] = [];
    }
}