<?php

class ColibriCron 
{

    private $colibri_object;
    private array $colibri = [
       [ 'colibri_id' => '',
        'author' => '',
        'vendor_name' =>'',
        'colibri_items' => [
            
        ],
        'vendor_email'=> '']
    ];
    private $wp_api_root;
    private \collection $db;
    private $log = [
        'total_colibri' => 0,
        'total_email_sending_failures' => 0,
        'new_processes_started' => 0,
    ];
    public $cronDate;

    public function __construct(string $wp_api_root)
    {
        $this->db = new \collection;
        $this->wp_api_root = $wp_api_root;
        $this->setColibriList();
    }
    public function destroy($colibri_id = '')
    {
        //die(var_dump($colibri_id));
        $this->disableColibri($colibri_id );
        return;
    }
    protected function disableColibri($colibri_id){
        if (isset($colibri_id) && $colibri_id == '') {
            die($colibri_id);
            throw new \Exception( "Colibri invalido", 400);
        } else {
            $where = [
                'colibri_id' => $colibri_id
            ];
        }
        $values = ['status' => 0];
        $this->db->update('ng_colibri', $where, $values);
        return;
    }
    private function setColibriList(){
       
        $colibri_query = str_replace(
            'OvMdW_',
            TABLE_PREFIX,
            "SELECT ng_colibri.colibri_id,ng_colibri.status, OvMdW_users.user_email, OvMdW_users.display_name, OvMdW_users.ID as vendor_ID, ANY_VALUE(TIMESTAMPDIFF(DAY, ng_colibri.create_at,NOW())) as active_time FROM `ng_colibri` INNER JOIN ng_colibri_items ON ng_colibri_items.colibri_id = ng_colibri.colibri_id INNER JOIN OvMdW_posts ON OvMdW_posts.ID = ng_colibri_items.product_id INNER JOIN OvMdW_users ON OvMdW_posts.post_author = OvMdW_users.ID GROUP BY colibri_id, OvMdW_users.ID HAVING `active_time`>=1 and ng_colibri.status = 1 ORDER BY `active_time` ASC LIMIT 100"
        );
        $colibri_results = $this->db->plainQuery($colibri_query);
        //die("HOLA");
        $count = 0;
        if ($colibri_results['cant_rows'] > 0) {
            foreach ($colibri_results as $key => $val) {

                if ($key == 'cant_rows') {
                    continue;
                }
                
                $this->colibri[$count] = array(
                    'colibri_id' => $val['colibri_id'],
                    'vendor_email' => $val['user_email'],
                    'vendor_name'=> $val['display_name'],
                    'author' => $val['vendor_ID'],
                    'colibri_items' =>$this->getColibriProducts($val['colibri_id'])
                );
                //die(var_dump($this->colibri));
                $this->sendEmailToVendors( $val['display_name'],$val['user_email'],$this->colibri[$count]['colibri_items'],$val['colibri_id']);
                $this->destroy($val['colibri_id']);
                $count++;
            }
        } else {
            throw new \Exception("No hay correos que enviar", 1);
        }

        //die(var_dump($this->colibri));
        $this->log['total_colibri'] = count($this->colibri);
        
    }
   
    private function getColibriProducts($colibri_id){
        $colibri_query = str_replace(
            'OvMdW_',
            TABLE_PREFIX,
            "SELECT product_id, quantity FROM `ng_colibri_items` WHERE `colibri_id` = ".$colibri_id."
            LIMIT 10"
        );
        $products_results = $this->db->plainQuery($colibri_query);
        $products =[];
        $count = 0;
        if ($products_results['cant_rows'] > 0) {
            foreach ($products_results as $key => $val) {

                if ($key == 'cant_rows') {
                    continue;
                }
                $products[$count] = array(
                    'product_id' =>$val['product_id'],
                    'meta_data'=>$this->getMetaFromProducts(array($val['product_id'])),
                    'quantity'=> $val['quantity']
                );
                $count++;
            }
        } else {
            throw new \Exception("No hay correos que enviar", 1);
        }
       return $products;
    }
    private function getMetaFromProducts($products_id = []){
        $products = new Products;
       return $products->searchById($products_id);
    }

    private function sendEmailToVendors($vendor_name, $vendor_email, $products, $colibri_link){
        try {
            $url = 'https://staggbm02.bridgemarkets.com/colibri/';
            $email= new email();
            $email->set_destination($vendor_email);
            $link = $colibri_link;
            $replace_vars = array(
                '{{colibri_link}}' => $url.$link,
                '{{vendor_name}}' => $vendor_name,
                '{{row_content}}' => implode(array_map([$this,'assignProductToRow'],$products))
            );
            $email->load_template('El link colibrí ha caducado',('email/colibri_expiration_notification'));
            $email->setReplace($replace_vars);

/* 
            $email->attachImageToBody('../../templates/assets/Frame_27294.png','colibri_logo');
            $email->attachImageToBody('../../templates/assets/brand.png','logo_bm');
            $email->attachImageToBody('../../templates/assets/akar-icons_facebook-fill.png','fb');
            $email->attachImageToBody('../../templates/assets/ant-design_instagram-filled.png','ig');
            $email->attachImageToBody('../../templates/assets/mail_outline.png','mail');
            $email->attachImageToBody('../../templates/assets/phone.png','phone');
            $email->attachImageToBody('../../templates/assets/Vector.png','ln');
            $email->attachImageToBody('../../templates/assets/whatsapp.png','wa');
            $email->attachImageToBody('../../templates/assets/x-twitter.png','x'); */
            
           // die(var_dump($replace_vars['{{row_content}}']));
            
            if($email->send_mail()){
                $response['message'] = 'El correo electrónico enviado.';
                $rest = new RestResponse(true, $response);
                $rest->toJson()->setMessage('OK');
            }else{
                $response['message'] = 'Correo electrónico no enviado.';
                $rest = new RestResponse(false, $response);
                $rest->toJson()->setMessage('Correo electrónico no enviado.');
            }
            
        } catch (\Throwable $th) {
            die($th);
        }
        
    }
    private function assignProductToRow($product){
        //die(var_dump($product));

        $row = '
        <tr>
            <td style="color:#636363;border:1px solid #e5e5e5;padding:12px;text-align:left;vertical-align:middle;font-family:"Helvetica Neue",Helvetica,Roboto,Arial,sans-serif;word-wrap:break-word" align="left">
                <a href="https://staggbm02.bridgemarkets.com/detalle/'.$product['meta_data'][0]['slug'].'" style="font-weight:normal;text-decoration:underline;color:#474748" target="_blank" data-saferedirecturl="https://www.google.com/url?q=https://staggbm02.bridgemarkets.com/detalle/'.$product['meta_data'][0]['slug'].'&amp;source=gmail&amp;ust=1721312439876000&amp;usg=AOvVaw0Br_f-Fazs8L4a50uuShmP">'.$product['meta_data'][0]['name'].'</a><br>
            </td>
            <td style="color:#636363;border:1px solid #e5e5e5;padding:12px;text-align:left;vertical-align:middle;font-family:"Helvetica Neue",Helvetica,Roboto,Arial,sans-serif" align="left">
                '.$product['quantity'].' </td>
            <td style="color:#636363;border:1px solid #e5e5e5;padding:12px;text-align:left;vertical-align:middle;font-family:"Helvetica Neue",Helvetica,Roboto,Arial,sans-serif" align="left">
                <span><span>USD $</span>'.$product['meta_data'][0]['price']*$product['meta_data'][0]['moq']*$product['quantity'].'</span>
            </td>
        </tr>
        ';

        return $row;
    }
}

