<?php

class collection
{

    private $db;
    private $where = array();
    private $order = array();
    private $limit = array();
    private $force = false;

    public function __construct()
    {
        $this->db = new dbclass();
    }
    /**
     *
     */
    public function getIdField($_bd_table)
    {
        return $this->db->get_id_name($_bd_table);
    }

    public function plainQueryJson($query, $void = false)
    {
        $json['response'] = array();
        try {
            $result = $this->db->execute_query_plain($query);
            for ($i = 0; $i < $result['cant_rows']; $i++) {

                array_push($json['response'], $result[$i]);
            }
            return $json;
        } catch (ErrorException $e) {
            echo 'Caught exception: ', $e->getMessage(), "\n";
        }
    }

    public function getField($_bd_table, $id, $field)
    {
        $tempData = $this->get($_bd_table, $id, 1);
        return $tempData[0][$field];
    }
    public function setArrayId($_bd_table, $var)
    {
        $name = $this->getIdField($_bd_table);
        return array($name => $var);
    }

    public function sanitizeData($arr)
    {
        return $this->db->sanitize($arr);
    }
    public function unsanitizeData($arr)
    {
        return $this->db->xss_reload($arr);
    }

    public function prepareWhere($arr, $equal = 'AND', $filter = 'DEFAULT_WHERE', $_bd_table)
    {
        return $this->db->prepareWhere($arr, $equal, $filter, $_bd_table);
    }

    public function insert($_bd_table = '', $data = array(), $id = 'null')
    {
        $insertData = $this->db->prepareDataRecord($_bd_table, $data);
        try {
            $key = $this->db->get_id_name($_bd_table);
            // $id = $this->db->getUniqueId();
            $value = $id;
            foreach ($insertData as $k => $vk) {
                $key .= ", `" . $k . "`";
                $value .= ", '" . $vk . "'";
            }
            $query = "INSERT INTO `" . $_bd_table . "` (" . $key . ") VALUES (" . $value . ");";
            // if($_bd_table == "OvMdW_wc_product_meta_lookup"){
            //     die($query);
            // }
            $id_ins = $this->db->execute_query_insert($query);
            return $id_ins;
        } catch (ErrorException $e) {
            echo 'Caught exception: ', $e->getMessage(), "\n";
        }
    }
    public function union($mergedArray = array(), $items = array(), $separator = '')
    {
        $initCount = (isset($mergedArray['cant_rows'])) ? $mergedArray['cant_rows'] : 0;
        $separatorItem = $initCount;
        $itemsCount = (isset($items['cant_rows'])) ? $items['cant_rows'] : count($items);

        for ($i = 0; $i < $itemsCount; $i++) {
            $mergedArray[$initCount] = $items[$i];
            $initCount++;
        }
        if ($separator != '') {
            $mergedArray[$separatorItem]['separator'] = $separator;
        }
        $mergedArray['cant_rows'] = $initCount;
        //var_dump($mergedArray);
        return $mergedArray;
    }
    public function delete($_bd_table = '', $data = array())
    {
        if (!is_array($data)) {
            $idField = $this->getIdField($_bd_table);
            $data = array($idField => $data);
        }
        $whereData = $this->db->prepareDataRecord($_bd_table, $data, false);
        try {
            $where = $this->db->prepareWhere($whereData, 'AND', 'DEFAULT_WHERE', $_bd_table);
            //$this->trash($_bd_table, $where);
            $query = "DELETE FROM `" . $_bd_table . "` WHERE (" . $where . ")";
            $this->db->execute_query_void($query);
            return true;
        } catch (ErrorException $e) {
            echo 'Caught exception: ', $e->getMessage(), "\n";
        }
    }

    private function trash($_bd_table, $where)
    {
        $data = $this->plainQuery("SELECT * FROM `" . $_bd_table . "` WHERE (" . $where . ")");
        for ($i = 0; $i < $data['cant_rows']; $i++) {
            $insert['trash_id'] = $this->db->getUniqueId();
            $insert['user_id'] = $_SESSION['user_data']['user_id'];
            $insert['date'] = date('Y-m-d H:i:s');
            $insert['_bd_table_reference'] = $_bd_table;
            $insert['reference_id'] = $data[$i][0];
            $insert['data'] = json_encode($data[$i]);
            $this->plainQuery("INSERT INTO `tb-trash` (`trash_id`,`user_id`,`date`,`_bd_table_reference`,`reference_id`,`data`) VALUES ('" . $insert['trash_id'] . "','" . $insert['user_id'] . "','" . $insert['date'] . "','" . $insert['_bd_table_reference'] . "','" . $insert['reference_id'] . "','" . $insert['data'] . "');", true);
            unset($insert);
        }
    }

    public function truncate($_bd_table = '')
    {
        try {
            $query = "TRUNCATE _bd_table " . $_bd_table . " ";
            $this->db->execute_query_void($query);
            return true;
        } catch (ErrorException $e) {
            echo 'Caught exception: ', $e->getMessage(), "\n";
        }
    }

    public function update($_bd_table = '', $where = array(), $data = array())
    {
        if (!is_array($where)) {
            $idField = $this->getIdField($_bd_table);
            $where = array($idField => $where);
        }
        $whereData = $this->db->prepareDataRecord($_bd_table, $where, false);
        $insertData = $this->db->prepareDataRecord($_bd_table, $data);
        try {
            $where = $this->db->prepareWhere($whereData, 'AND', 'DEFAULT_WHERE', $_bd_table);
            $value = '';
            foreach ($insertData as $k => $vk) {
                if ($value == '') {
                    $value .= "`" . $k . "`='" . $vk . "'";
                } else {
                    $value .= ",`" . $k . "`='" . $vk . "'";
                }
            }
            $value = ltrim($value, ",");
            $query = "UPDATE `" . $_bd_table . "` SET " . $value . " WHERE (" . $where . ")";
            $this->db->execute_query_void($query);
            return true;
        } catch (ErrorException $e) {
            echo 'Caught exception: ', $e->getMessage(), "\n";
        }
    }

    public function get($_bd_table = '', $id = 0, $limit = '250', $order = '')
    {
        try {
            $idField = $this->getIdField($_bd_table);
            $query = "SELECT * FROM `" . $_bd_table . "`";
            $queryCount = "SELECT COUNT(" . $idField . ") FROM `" . $_bd_table . "`";
            if ($id != '' || $id != 0) {
                $idSearch = array($idField => $id);
                $whereData = $this->db->prepareWhere($this->db->prepareDataRecord($_bd_table, $idSearch, false), 'AND', 'DEFAULT_WHERE', $_bd_table);
                $query .= " WHERE " . $whereData;
                $queryCount .= " WHERE " . $whereData;
            }
            if ($order != '') {
                $query .= " ORDER BY " . $order . " ";
            } else {
                $query .= " ORDER BY " . $idField . " ASC";
            }

            if ($id != 0 && $id != '' && $limit == '') {
                $query .= " LIMIT 1";
            } else {
                $query .= " LIMIT " . $limit;
            }
            $result = $this->db->execute_query($query);
            return $result;
        } catch (ErrorException $e) {
            echo 'Caught exception: ', $e->getMessage(), "\n";
        }
    }
    /**
     * @param $filter String DEFAULT_WHERE / INIT_LIKE / END_LIKE / BOTH_LIKE
     */
    public function search($_bd_table = '', $where = '', $comparation = 'AND', $filter = 'DEFAULT_WHERE', $limit = '250', $order = '', $group = '')
    {
        try {
            $idField = $this->getIdField($_bd_table);

            $query = "SELECT * FROM `" . $_bd_table . "`";
            $queryCount = "SELECT COUNT(" . $idField . ") FROM `" . $_bd_table . "`";
            if (is_array($where)) {
                $whereData = $this->db->prepareWhere($this->db->prepareDataRecord($_bd_table, $where, false), $comparation, $filter, $_bd_table);
                $query .= " WHERE " . $whereData;
                $queryCount .= " WHERE " . $whereData;
            } else {
                $where = array($idField => $where);
                $whereData = $this->db->prepareWhere($this->db->prepareDataRecord($_bd_table, $where, false), $comparation, $filter, $_bd_table);
                $query .= " WHERE " . $whereData;
                $queryCount .= " WHERE " . $whereData;
            }
            if ($group != '') {
                $query .= " GROUP BY " . $group . " ";
                $queryCount .= " GROUP BY " . $group . " ";
            }
            if ($order != '') {
                $query .= " ORDER BY " . $order . " ";
            } else {
                $query .= " ORDER BY " . $idField . " ASC";
            }

            $query .= " LIMIT " . $limit;
            $result = $this->db->execute_query($query);
            return $result;
        } catch (ErrorException $e) {
            echo 'Caught exception: ', $e->getMessage(), "\n";
        }
    }
    /**
     * @param $filter String DEFAULT_WHERE / INIT_LIKE / END_LIKE / BOTH_LIKE
     */
    public function searchForce($_bd_table = '', $where = '', $comparation = 'AND', $filter = 'DEFAULT_WHERE', $limit = '250', $order = '', $group = '')
    {
        try {
            $idField = $this->getIdField($_bd_table);

            $query = "SELECT * FROM `" . $_bd_table . "`";
            $queryCount = "SELECT COUNT(" . $idField . ") FROM `" . $_bd_table . "`";
            if (is_array($where)) {
                $whereData = $this->db->prepareWhere($this->db->prepareDataRecord($_bd_table, $where, false), $comparation, $filter, $_bd_table);
                $query .= " WHERE " . $whereData;
                $queryCount .= " WHERE " . $whereData;
            } else {
                $where = array($idField => $where);
                $whereData = $this->db->prepareWhere($this->db->prepareDataRecord($_bd_table, $where, false), $comparation, $filter, $_bd_table);
                $query .= " WHERE " . $whereData;
                $queryCount .= " WHERE " . $whereData;
            }
            if ($group != '') {
                $query .= " GROUP BY " . $group . " ";
                $queryCount .= " GROUP BY " . $group . " ";
            }
            if ($order != '') {
                $query .= " ORDER BY " . $order . " ";
            } else {
                $query .= " ORDER BY " . $idField . " ASC";
            }

            $query .= " LIMIT " . $limit;
            $result = $this->db->execute_query($query,true);
            return $result;
        } catch (ErrorException $e) {
            echo 'Caught exception: ', $e->getMessage(), "\n";
        }
    }

    public function plainQuery($query, $void = false,$force=false)
    {
        try {
            if ($void) {
                $result = $this->db->execute_query_void($query);
                return $result;
            } else {
                $result = $this->db->execute_query($query,$force);
                return $result;
            }
        } catch (ErrorException $e) {
            echo 'Caught exception: ', $e->getMessage(), "\n";
        }
    }
    public function MixedQuery($queryString = '', $_bd_table = '', $where = '', $comparation = 'AND', $filter = 'DEFAULT_WHERE', $limit = '250', $order = '')
    {
        try {
            if ($queryString == '') {
                $queryString = "SELECT * FROM `" . $_bd_table . "`";
            }
            $idField = $this->getIdField($_bd_table);

            $query = $queryString;
            $queryCount = "SELECT COUNT(" . $idField . ") FROM `" . $_bd_table . "`";
            if (is_array($where)) {
                $whereData = $this->db->prepareWhere($this->db->prepareDataRecord($_bd_table, $where, false), $comparation, $filter, $_bd_table);
                $query .= " WHERE " . $whereData;
                $queryCount .= " WHERE " . $whereData;
            } else {
                $where = array($idField => $where);
                $whereData = $this->db->prepareWhere($this->db->prepareDataRecord($_bd_table, $where, false), $comparation, $filter, $_bd_table);
                $query .= " WHERE " . $whereData;
                $queryCount .= " WHERE " . $whereData;
            }
            if ($order != '') {
                $query .= " ORDER BY " . $order . " ";
            } else {
                $query .= " ORDER BY " . $idField . " ASC";
            }
            $query .= " LIMIT " . $limit;
            $result = $this->db->execute_query($query);
            $count = $this->db->execute_query($queryCount);
            $result['count'] = count($count);
            return $result;
        } catch (ErrorException $e) {
            echo 'Caught exception: ', $e->getMessage(), "\n";
        }
    }
}