<?php
class CurlRequest
{
	private $data;
	private $error;
	private $user;
	private $pass;
	private $autorization;
	private $status;
	private $contentType = 'application/json';
	private $headers = [];

	public function __construct($user='',$pass='',$encode=true)
	{
		$this->user=$user;
		$this->pass=$pass;
		if($user!='' && $pass!=''){
			if($encode){
				$this->autorization=base64_encode($this->user . ":" . $this->pass);
			}else{
				$this->autorization=$this->user . ":" . $this->pass;
			}
			$this->addHeaders("Authorization: Basic ".$this->autorization);
		}
		
		
	}

	public function addHeaders($header)
	{
		$this->headers[]=$header;
	}

	/**
	 * generateRequest Data
	 * @param string $url url to generate request
	 * @param string $type type of request
	 * @param string $content in json format
	 */
	public function request($url = NULL, $type='POST', $content=null)
	{
		if ($url == NULL) return false;
		$this->addHeaders("Content-Type: ".$this->contentType);
		$ch = curl_init();
            curl_setopt_array($ch, [
                CURLOPT_URL => $url,
                CURLOPT_RETURNTRANSFER => true,
				CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 30,
				CURLOPT_SSL_VERIFYPEER => false,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => $type,
                CURLOPT_POSTFIELDS => $content,
                CURLOPT_HTTPHEADER => $this->headers,
            ]);
		$this->data = curl_exec($ch);
		$this->error = curl_error($ch);
		$httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
		curl_close($ch);
		if ($httpcode >= 200 && $httpcode < 300) {
            $this->status=true;
			return $this->data;
		} else {
            $this->status=false;
			return $this;
		}
	}
	public function toJson()
	{
		return json_encode($this->data);
	}
	public function contentForm()
	{
		$this->contentType='multipart/form-data';
		return $this;
	}
	public function contentFormurlEncode()
	{
		$this->contentType='application/x-www-form-urlencoded; charset=UTF-8';
		return $this;
	}
	public function toObject()
	{
		return json_decode($this->data, true);
	}
	public function rawData()
	{
		return $this->data;
	}
	public function showErrors()
	{
		return $this->error;
	}
	public function status()
	{
		return $this->status;
	}
}