<?php

require($approot.'vendor/phpmailer/phpmailer/src/PHPMailer.php');
require($approot.'vendor/phpmailer/phpmailer/src/Exception.php');
require($approot.'vendor/phpmailer/phpmailer/src/SMTP.php');

//These must be at the top of your script, not inside a function
use PHPMailer\PHPMailer\Exception;
use PHPMailer\PHPMailer\PHPMailer;

class email
{
    private $mail;
    private $mail2;
    private $collection;
    private $replace = array();
    public $temp;
    public $to_send = array();
    public $arr_save = array();
    public $template = array();
    public $id_user = '';
    public $id_user_copy = '';
    public $lang = '';
    public $mail_lang = '';
    public $mail_type = '';
    public $to_sendcopy = array();
    public $cita = '';
    private $logged = false;

    public function __construct($lang = 'es')
    {

        $this->collection = new collection;
        //Instantiation and passing `true` enables exceptions
        $this->mail = new PHPMailer(true);
        //$this->mail->SMTPDebug = SMTP::DEBUG_SERVER;                      //Enable verbose debug output
        $this->mail->isSMTP(); //Send using SMTP
        $this->mail->CharSet = 'UTF-8';
        $this->mail->Host = SMTP_HOST; //Set the SMTP server to send through
        $this->mail->SMTPAuth = true; //Enable SMTP authentication
        $this->mail->Username = SMTP_USER; //SMTP username
        $this->mail->Password = SMTP_PASS; //SMTP password
        $this->mail->SMTPSecure = PHPMailer::ENCRYPTION_SMTPS; //Enable TLS encryption; `PHPMailer::ENCRYPTION_SMTPS` encouraged
        $this->mail->Port = 465;
    }

    public function load_template($title='',$mail_type = '')
    {
        global $approot;
        $this->template['title']=utf8_decode($title) ;

        if(file_exists($approot.'templates/'.$mail_type.'.php')){
            $this->template['content']=utf8_decode(file_get_contents($approot.'templates/'.$mail_type.'.php'));
            return true;
        }
        return false;       
    }
    public function set_template($title = '', $content = '')
    {
        $this->template['title'] = utf8_encode(utf8_decode($title));
        $this->template['content'] = utf8_encode(utf8_decode($content));
    }
    private function replace_data()
    {
        foreach ($this->replace as $key => $value) {
            $this->template['title'] = str_replace($key, $value, $this->template['title']);
            $this->template['content'] = str_replace($key, $value,$this->template['content']);
        }
    }
    public function setReplace($vars = array())
    {
        if (is_array($vars)) {
            foreach ($vars as $key => $value) {
                $this->replace[$key] = $value;
            }
        }
    }
    public function set_destination($var = '')
    {
        $this->to_send[]=$var;
    }

    public function set_multidestination(Array $var)
    {
        foreach ($var as $value) {
            $this->to_send[]=$value;
        }
    }
    public function set_copyCC($var = '')
    {
        $this->to_sendcopy = $var;
    }
    public function attach($var = '')
    {
        $this->mail->addAttachment($var);
        return $this;
    }
    public function attachImageToBody($file_path, $cid, $name ='')
{
    //die(var_dump($this));
    $this->mail->AddEmbeddedImage( $file_path, $cid, $name);
    return $this;

}
    private function prepare()
    {

        $this->mail->setFrom(SMTP_REPLY, 'www.bridgemarkets.com');
        
        if (count($this->to_send) > 0) {
            foreach ($this->to_send as $key => $value) {
                $this->mail->addAddress($value);
            }
            
        }
        //$this->mail->addAddress('ellen@example.com');               //Name is optional
        $this->mail->addReplyTo(SMTP_REPLY, 'No Responder');
        if (count($this->to_sendcopy) > 0) {
            $this->mail->addCC($this->to_sendcopy);
        }
        $this->replace_data();
        $this->mail->isHTML(true); //Set email format to HTML
        $this->mail->Subject = $this->template['title'];
        $this->mail->Body = $this->template['content'];
        $this->mail->AltBody = 'To view the message, please use an HTML compatible email viewer!';
    }
    public function send_mail()
    {
        try {
            $this->prepare();
            if (SENDMAIL == 1) {
                $this->mail->send();
                return true;;
            } else {
                if (VIEWMAIL == 1) {
                    $this->show_mail();
                }
            }
            //echo 'Message has been sent';
            $this->log($this->to_send, $this->template['content'], 'send');
        } catch (Exception $e) {
            //echo "Message could not be sent. Mailer Error: {$this->mail->ErrorInfo}";
            $this->log($this->to_send, $this->template['content'], $this->mail->ErrorInfo);
            return false;
        }
    }

    public function log($destination, $body, $status)
    {

        if ($this->logged) {
            $ins = array(
                'date' => date('Y-m-d H:i:s'),
                'receiped' => $destination,
                'body' => $body,
                'status' => $status,
            );
            //$this->collection->insert('tb-log_mail', $ins);
        }
    }
    public function show_mail()
    {
        $this->prepare();
        echo '<<<<< message >>>><br>';
        echo $this->template['title'];
        echo '<br>';
        echo $this->template['content'];
        echo '<br>';
        echo '<<<<< end message >>>><br>';
    }
}