<?php

class ZohoCurl
{

    private string $url;
    private string $refresh_token;
    private string $method;
    private $data;
    private $error;
    private $user;
    private $pass;
    private $autorization;
    private $status;

    public function __construct()
    {
    }

    public function getTokenCode(string $refresh_token)
    {

        if ($refresh_token == null || $refresh_token == '') {
            throw new Exception('Parámetros inválidos o inexistentes');
        }

        $curlURL = ZOHO_REFRESH_ACCOUNT_URL . 'refresh_token=' . $refresh_token . '&client_id=' . ZOHO_CLIENT_ID . '&client_secret=' . ZOHO_CLIENT_SECRET . '&grant_type=refresh_token';

        $curl = curl_init();
        curl_setopt_array($curl, [
            CURLOPT_URL => $curlURL,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => null,
            CURLOPT_HTTPHEADER => [
                "Content-Type: application/json"
            ],
        ]);

        $this->data = curl_exec($curl);
        $this->error = curl_error($curl);
        $httpcode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        curl_close($curl);
        if ($httpcode >= 200 && $httpcode < 300) {
            $this->status = true;
            return $this;
        } else {
            $this->status = false;
            return $this;
        }
    }

    public function subscribe(string $data, $susbscribeListId)
    {

        if ($data == null || $data == '') {
            throw new Exception('Parámetros inválidos o inexistentes en la data');
        }

        //die($data);

        $auth = new ZohoAuth('ZohoCampaigns.contact');
        $curlURL = "https://campaigns.zoho.com/api/v1.1/json/listsubscribe?resfmt=JSON&listkey=" . $susbscribeListId . "&contactinfo=" . $data;

        $curl = curl_init();
        curl_setopt_array($curl, [
            CURLOPT_URL => $curlURL,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => null,
            CURLOPT_HTTPHEADER => [
                "Content-Type: application/x-www-form-urlencoded",
                "Authorization: Zoho-oauthtoken " . $auth->access_token
            ],
        ]);
        $this->data = curl_exec($curl);
        $this->error = curl_error($curl);
        $httpcode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        curl_close($curl);
        if ($httpcode >= 200 && $httpcode < 300) {
            $this->status = true;
            return $this;
        } else {
            $this->status = false;
            return $this;
        }
    }

    public function postModule(string $moduleName, $data){

        if ($data == "") {
            throw new Exception('Tiene que introducir data para poder realizar esta acción.');
        }
        if(!$moduleName || $moduleName == null  || $moduleName == ""){
            throw new Exception("Nombre de módulo inválido o vacío.", 1);
        }

        $auth = new ZohoAuth('ZohoCRM.modules');
        $curlURL = "https://www.zohoapis.com/crm/v3/" . $moduleName;

        $curl = curl_init();
        curl_setopt_array($curl, [
            CURLOPT_URL => $curlURL,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => $data,
            CURLOPT_HTTPHEADER => [
                "Content-Type: application/x-www-form-urlencoded",
                "Authorization: Zoho-oauthtoken " . $auth->access_token
            ],
        ]);
        $this->data = curl_exec($curl);
        $this->error = curl_error($curl);
        $httpcode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        curl_close($curl);
        if ($httpcode >= 200 && $httpcode < 300) {
            $this->status = true;
            return $this;
        } else {
            $this->status = false;
            return $this;
        }

    }

    public function toJson()
    {
        return json_encode($this->data);
    }
    public function toObject()
    {
        return json_decode($this->data, true);
    }
    public function rawData()
    {
        return $this->data;
    }
    public function showErrors()
    {
        return $this->error;
    }
    public function status()
    {
        return $this->status;
    }
}
