<?php
use InventoryManagement\InventoryCron;
require('../../cfg.php');
$errors=[];

if (true) {
    $requestMethod = $_SERVER["REQUEST_METHOD"];
    switch ($requestMethod) {
        case 'GET':

            switch($_GET['action']){
                case 'cron':
                    try {
                        
                        $cron = new InventoryManagement\InventoryCron($wp_api_root);
                        $data = $cron->initCron();

                        if (!isset($data)) {
                            $data = [];
                        }
                        $rest = new RestResponse(true, $data);
                        $rest->toJson()->setMessage('OK');
                        if (!empty($errors)) {
                            $rest->setError($errors);
                        }

                    } catch (\Throwable $th) {
                        $rest = new RestResponse(false, $th->getMessage());
                        $rest->toJson()->setMessage('fail');
                    }

                break;
            }
            
        case 'POST':
            switch($_GET['action']){
                case 'checkAvailability':
                    try {
                        if(isset($_GET['identifier'])){
                            $inventory = new InventoryManagement\InventoryManager();
                            $data = $inventory->checkIfLinkIsValid($_GET['identifier']);

                            if($data == 'true'){
                                $rest = new RestResponse(true, $data);
                                $rest->toJson()->setMessage('OK');
                                if (!empty($errors)) {
                                    $rest->setError($errors);
                                }
                            }
                        }

                    } catch (\Throwable $th) {
                        $rest = new RestResponse(false, $th->getMessage());
                        $rest->toJson()->setMessage('fail');
                    }

                break;
                case 'loadProducts':
                    try {
                        
                        if(!isset($_GET['identifier'])){
                            throw new Exception("No ha facilitado el codigo de autenticacion");
                        }

                        if(!isset($_GET['queryLimit'])){
                            throw new Exception("No ha facilitado el limite de resultados");
                        }

                        if(!isset($_GET['page'])){
                            throw new Exception("No ha facilitado la pagina de los resultados");
                        }

                        $ProductManager = new InventoryManagement\ProductManager;
                        $vendorProducts = $ProductManager->getVendorProducts($_GET['identifier'], $_GET['page'], $_GET['queryLimit']);

                        $rest = new RestResponse(true, $vendorProducts);
                                $rest->toJson()->setMessage('OK');
                                if (!empty($errors)) {
                                    $rest->setError($errors);
                                }

                    } catch (\Throwable $th) {
                        $rest = new RestResponse(false, $th->getMessage());
                        $rest->toJson()->setMessage('fail');
                    }
                break;
                case 'approveProducts':
                    try {
                        $ProductManager = new InventoryManagement\ProductManager;
                        $data = json_decode(file_get_contents("php://input"), true);

                        if(!isset($_GET['identifier'])){
                            throw new Exception("No ha facilitado el codigo de autenticacion");
                        }

                        $ProductManager->handleProductState(identifier:$_GET['identifier'], inactiveProducts:$data['unapproved']);
                        $ProductManager->inventoryIsUpdated($_GET['identifier'], $data);

                        $rest = new RestResponse(true, "OK");
                                $rest->toJson()->setMessage('OK');
                                if (!empty($errors)) {
                                    $rest->setError($errors);
                                }


                    } catch (\Throwable $th) {
                        $rest = new RestResponse(false, $th->getMessage());
                        $rest->toJson()->setMessage('fail');
                    }
                break; 
                }
                
        case 'PUT':

            break;
        case 'DELETE':

            break;
        default:


            break;
    }
}
if (!isset($rest) || !is_object($rest)) {
    $rest = new RestResponse(false, null);
    $rest->toJson()->setMessage('Acceso Restringido');
}
$rest->execute();
