<?php
require('../../cfg.php');
$auth = new auth();
if ($auth->verify($auth->found())->status()) {
    $requestMethod = $_SERVER["REQUEST_METHOD"];
    switch ($requestMethod) {
        case 'GET':
            try {
                switch ($_GET["action"]) {
                    case 'list':
                        $page = (isset($_GET['page']) && $_GET['page'] != '') ? $_GET['page'] : 1;
                        $count = (isset($_GET['count']) && $_GET['count'] != '') ? $_GET['count'] : 10;
                        $orders = new Orders($auth->getUser());
                        $data = $orders->getAll($page, $count);
                        $rest = new RestResponse(true, $data);
                        $rest->toJson()->setMessage('OK');
                        break;
                    case 'details':
                        $order = (isset($_GET['order']) && $_GET['order'] != '') ? $_GET['order'] : 0;
                        $orders = new Orders($auth->getUser());
                        $data = $orders->getDetails($order);
                        $rest = new RestResponse(true, $data);
                        $rest->toJson()->setMessage('OK');
                        break;
                    default:
                        $page = (isset($_GET['page']) && $_GET['page'] != '') ? $_GET['page'] : 1;
                        $count = (isset($_GET['count']) && $_GET['count'] != '') ? $_GET['count'] : 10;
                        $orders = new Orders($auth->getUser());
                        $data = $orders->getAll($page, $count);
                        $rest = new RestResponse(true, $data);
                        $rest->toJson()->setMessage('OK');
                        break;
                }
            } catch (\Throwable $th) {
                $rest = new RestResponse(false, null);
                $rest->toJson()->setMessage($th->getMessage());
            }

            break;
        case 'POST':
            try {
                switch ($_GET["action"]) {
                    case 'refundContact':
                        $request = json_decode(file_get_contents("php://input"));
                        $email = new email();
                        $email->set_multidestination(LOGISTICS_EMAIL_NOTIFICATIONS);
                        $email->set_template($request->subject, $request->message);
                        if ($email->send_mail()) {
                            $response['message'] = 'El correo electrónico enviado.';
                            $rest = new RestResponse(true, $response);
                            $rest->toJson()->setMessage('El correo electrónico enviado.');
                        } else {
                            $response['message'] = 'Correo electrónico no enviado.';
                            $rest = new RestResponse(false, $response);
                            $rest->toJson()->setMessage('Correo electrónico no enviado.');
                        }
                    break;
                    case 'setTransferData':
                        $request = json_decode(file_get_contents("php://input"),true);
                        if ($request['client_order_number']!='') {
                            $order = new Orders($auth->getUser());
                            $user = new User($auth->getUser());
                            $order_id=$request['client_order_number'];
                            unset($request['client_order_number']);
                            $order->setOrderMeta($order_id,$request);
                            $order->sendEmailNotificationToAdministration($order_id,$user->first_name.' '.$user->last_name);
                            $response['message'] = 'Datos recibidos.';
                            $rest = new RestResponse(true, $response);
                            $rest->toJson()->setMessage('Datos recibidos.');
                        } else {
                            $response['message'] = 'Error al procesar a solicitud';
                            $rest = new RestResponse(false, $response);
                            $rest->toJson()->setMessage('Error al procesar a solicitud');
                        }
                    break;
                }
            } catch (\Throwable $th) {
                $rest = new RestResponse(false, null);
                $rest->toJson()->setMessage($th->getMessage());
            }
            break;
        case 'PUT':

            break;
        case 'DELETE':
            
            break;
        default:


            break;
    }
}
if (!isset($rest) || !is_object($rest)) {
    $rest = new RestResponse(false, null);
    $rest->toJson()->setMessage('Acceso Restringido');
}
$rest->execute();
