<?php
require('../../cfg.php');
// this data will be returned encrypted changing all toJson()methods to encrypt() method in RestResponse object
/**
 * encryption method to red encrypted request
 * $request = json_decode(secureToke::decrypt(file_get_contents("php://input")), true);
 */
$auth = new auth();
if ($auth->verify($auth->found())->status()) {
    $requestMethod = $_SERVER["REQUEST_METHOD"];
    switch ($requestMethod) {
        case 'GET':
            try {
                $data = [];
                if(isset($_GET['payment_method'])){
                    $payment = new Payment($auth->getUser());
                    $payment->setProvider($_GET['payment_method']);
                    $payment->loadMethod();
                    $data=$payment->getResponse();
                }
                $rest = new RestResponse(true, $data);
                $rest->toJson()->setMessage('OK');
            } catch (\Throwable $th) {
                $rest = new RestResponse(false, null);
                $rest->toJson()->setMessage($th->getMessage());
            }
            break;
        case 'POST':
            try {
                if (isset($_GET['action']) && $_GET['action'] == 'update') {
                    $request = json_decode(file_get_contents("php://input"), true);
                    if(isset($request['id']) && $request['id']!='' && $request['id']!='0' && isset($request['payment_method'])){
                        $payment = new Payment($auth->getUser());
                        $payment->setProvider($request['payment_method']);
                        $payment->class->updateOption($request['id'],$auth->getUser(),$request['payment_method'],$request['data']);
                        $payment->loadMethod();
                        $data=$payment->getResponse();
                    }else{
                        $payment = new Payment($auth->getUser());
                        $payment->setProvider($request['payment_method']);
                        $payment->class->addOption($auth->getUser(),$request['payment_method'],$request['data']);
                        $payment->loadMethod();
                        $data=$payment->getResponse();
                    }
                }
                if (isset($_GET['action']) && $_GET['action'] == 'delete') {
                    $request = json_decode(file_get_contents("php://input"), true);
                    if(isset($request['id']) && $request['id']!='' && $request['id']!='0' && isset($request['payment_method'])){
                        $payment = new Payment($auth->getUser());
                        $payment->setProvider($request['payment_method']);
                        $payment->class->deleteOption($request['id'],$auth->getUser());
                        $payment->loadMethod();
                        $data=$payment->getResponse();
                    }
                }
                



                if (!isset($data)) {
                    $data = [];
                }
                

                $rest = new RestResponse(true, $data);
                $rest->toJson()->setMessage('OK');
            } catch (\Throwable $th) {
                $rest = new RestResponse(false, null);
                $rest->toJson()->setMessage($th->getMessage());
            }
            break;
        case 'PUT':

            break;
        case 'DELETE':

            break;
        default:


            break;
    }
}
if (!isset($rest) || !is_object($rest)) {
    $rest = new RestResponse(false, null);
    $rest->toJson()->setMessage('Acceso Restringido');
}
$rest->execute();
